*-------------------------------------------------------------*
c--------------------------------------------------------------------------
      subroutine CheckGrid()
      USE General
      USE Symmetry
      USE Mappa, only : factr, np
      USE PhaseModule
      USE Groups, only : nResidStored, nAcid
     
c
!mrt
***   ifRemo = 0 ! occhio, da ricontrollare!!!!!!!!!!

!     factr = -0.4     x Hydro

      if (kverbo > 0 .and. knw > 0) then
          write(6,*) 'CONTROLLO Factr IN =',factr
      endif

      if (factr < 0.0) then
          factr = abs(factr)
      else
          if (ifRemo == 1) then
             if (nAcid > 0 .and. nResidStored == 0) then
                 factr = resm / 4.0
             else
                 factr = resm / 3.0
             endif
          elseif (ifRemo == 2) then
             factr = 1.0 / 2.0
          elseif (ifRemo == 3) then
             factr= resm / 2.0 ! come era prima
          else
             if (LowRes == 0 .or. ifPatt > 0) then
                 factr = 1.0 / 3.0   ! risoluzione atomica (max 1.2)
                 if(ResEff>sogResEff.and.Complet>0.80) factr = 0.25
             else
                 if (ksize < 4) then
                     factr = 1.0 / 3.0
                 else
                     factr= resm / 3.0
                 endif
             endif

!            if (LowRes == 1 .and. no(nk) >= 20) factr = 0.25 !HEAVY  anche in Patterson
!            if (LowRes == 1 .and. jsys >= 4) factr = 0.25 ! anche in Patterson
***          if (LowRes == 1 ) factr = 0.25 !  sempre  (Tang o Patt e DSR)
!            if (LowRes == 1 .and. ifPatt == 1) factr = 0.25 ! solo in Patterson
cdedi
c
c--per limitare la memoria, faccio in modo che la cella non superi 360*360*360
c

Corig        term = 360*factr
             term = 320*factr   ! per usare la Cmap in Patterson in caso di strutture grandi
             do while(cell(1)*cell(2)*cell(3)>term*term*term)
               factr=factr+0.03
c              term = 360*factr   
               term = 320*factr   
             enddo
          endif
! per limitare l'approssimazione 
          if(factr>1.0) factr= 1.0
      endif
!pgMAD
      if (kmad.ne.0) then
          resm = 0.5/sqrt(rhomax)
          factr = resm / 3.0
          if (kmad == 1) then
              if (jjpatt.eq.1) then
                 factr = 0.5
              else
                 factr = 0.9
              endif
          endif
      endif
!pgMAD
c
c-- calculate number of grid points for fourier map
c
      do 130 i=1,3
         np(i)=cell(i)/factr+0.5
c
c        if(ifPatt==1) then   ! occhio
c          factr1 = factr
c          do while (np(i)>150)
c            factr1=factr1+0.05
c            np(i)=cell(i)/factr1+0.5
c          enddo
c        endif
c
         if (np(i).le.2*ihmx(i)) np(i)=2*ihmx(i)+1    ! Dritan
c        if (ifRemo >= 1) cycle
         if (i == 3) np(i) = np(i) + mod(np(i), 2)
  110    ntest=np(i)
*     write(6,*) 'Gridres 1 ',np
         do 120 j=2,5
  115       if (ntest.ne.(ntest/j)*j) go to 120
            ntest=ntest/j
            if (ntest == 1) go to 130
            go to 115
  120    continue
         np(i)=np(i)+1
         if (i == 3) np(i) = np(i) + 1
         go to 110
  130 continue
c
c--controllo messo da Liberato per limitare l'uso della memoria
c     da ricontrollare !!!!!!!!!!!
c-ULTIM
c     do i=1,3
c         if(np(i)>420) np(i)=420
c     enddo
c-ULTIM

c     if (ifRemo >= 1) then
c         call gridres()
c     endif
      if (kmad==2) then
          call gridres(resm)
          sumP=sum(cell(1:3)/np(1:3))
          factr=sumP/3.0
      endif
*         call gridres(resm)
!     
      if (kverbo > 0 .and. knw > 0) then
          write(6,*) 'CONTROLLO Factr OUT =',factr
      endif
!
      return
      end
!---------------------------------------------------
*-------------------------------------------------------------*
*-------------------------------------------------------------*
      subroutine ChangeAndInvMap(x,x1,jflagM,sogrho1,jflagE,ier)


      USE Riflessi
      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))

      common/puntic/npu1,npu2,npu3,npu4

 
*---- jflagM=0 Non modifica la densita'  ----*
*---- jflagM=1 Modifica la densita': troncare a " den_p "  ----*
*---- jflagM=11Modifica la densita': troncare  den_p pos e neg --*
*---- jflagM=2 Modifica la densita': troncare la parte negativa--*
*---- jflagM=7 Modifica la densita': troncare tra "den_s" e "den_p" (prende la parte piu' alta pos e piu' bassa neg)


      if (sogrho1.gt.0.0) then
          sog=avden+sogrho1*stden
      else
          sog=0.0
      endif
      npunti=np(1)*np(2)*np(3)

      n_p=0
      n_s=0
      npu1=0
      npu2=0
      npu3=0
      npu4=0

*---- Prima volta  fa la modifica
       call ChangeMapFlex (x,x1,sog,jflagM,jflagE)

      if (kverboCow > 0) then
       write(lo,*)'  ***************************************'
       write(lo,*)'  *          Inverse FFT Routine        *'
       write(lo,*)'  ***************************************'
      endif
      percT=float(n_p)/(float(npunti))
      perc=float(n_p)/(float(npunti)*v_p)
      if (perc.gt.1.0) perc=1.0

      if (kverboCow > 0) then
        write(lo,'(" jflagM = ",i4)') jflagM

        write(lo,1000)den_p/volume,n_p,percT*100.0,perc*100.0,
     +             npu2,100.0*float(npu2)/float(n_p),
     +             npu3,100.0*float(npu3)/float(n_p),
     +             den_s/volume,n_s,100.*float(n_s)/(float(npunti)),
     *             100.*float(n_s)/(float(npunti)*v_p),
     *             sog/volume,npu1
      endif

 1000 format(/,'   Minimum Density level (pos)........ ',f8.3,/,
     +       '   Grid point .gt. Level ............. ',i8,2x,
     +                                       2(1x,f6.1,'%'),/,
     +       '     a) in the envelope .............. ',i8,3x,f6.1,1h%,/,
     +       '     b) out of the envelope .......... ',i8,3x,f6.1,1h%,/,
     *       '   Minimum Density level (neg)........ ',f8.3,/,
     +       '   Grid point .lt. Level ............. ',i8,2x,
     +                                       2(1x,f6.1,'%'),/,
     +       '   Cut-off density ................... ',f8.3,/,
     +       '   Cut-off points .................... ',i8,/)


c     call NewInv(iphaz,fcvet,nrefl,np(1),np(2),np(3),BACK)
!!gpu call NewInv(iphaz,fcvet,nreflTot,np(1),np(2),np(3),BACK)
      call NewInvCuda(iphaz,fcvet,nreflTot,np(1),np(2),np(3),BACK,x)
      if (kverboCow > 0) then
       write(lo,*)'  ***************************************'
       write(lo,*)'  *      END Inverse FFT Routine        *'
       write(lo,*)'  ***************************************'
      endif

      return
      end
*----------------------------------------------------------------------------*
      subroutine MakeMap(fop,iphi2,numbrefl,jpatt,x,FORTHi,BACKi)

      USE General
      USE Symmetry
      USE Mappa, only : np, xmapC, FFTW_ESTIMATE, FFTW_MEASURE
      USE Param
      USE Riflessi, only : khl, work1, work2
!
      implicit none
      integer*8    :: FORTHi, BACKi
      integer      :: numbrefl, jpatt, j, jn, i2(3), iphi2(numbrefl)
      integer      :: n1, n2, n3, n0, i, l, ih, ik, il, lmod
      real         :: x(0:np(1)-1,0:np(2)-1,0:np(3)-1), fop(numbrefl)
      real         :: fourcoef, phase, phase1, twopim, ee, eep
      complex      :: fh, phasec, fm
!
      n1 = np(1)
      n2 = np(2)
      n3 = np(3)
      n0 = n1 / 2 + 1
!
!-- make plans
!
*     if (QualePgm == JAVPGM) then
          if (FORTHi == 0) then
             call sfftw_plan_dft_c2r_3d(FORTHi, n1, n2, n3, xmapC,x,
     *                                                 FFTW_ESTIMATE)
!C!               fftwf_plan_dft_c2r_3d(*n3, *n2, *n1, xmapC,xmap, *f)
             call sfftw_plan_dft_r2c_3d(BACKi,  n1, n2, n3, x,xmapC,
     *                                                 FFTW_ESTIMATE)
          endif
*         write(6,*) 'MakeMap ',FORTHi, BACKi, n1,n2,n3,FFTW_ESTIMATE
*     else
*         if (FORTHi == 0) then
*            call sfftw_plan_dft_c2r_3d(FORTHi, n1, n2, n3, xmapC,x,
*    *                                                 FFTW_MEASURE)
*            call sfftw_plan_dft_r2c_3d(BACKi,  n1, n2, n3, x,xmapC,
*    *                                                 FFTW_MEASURE)
*         write(6,*) 'MakeMap ',FORTHi, BACKi, n1,n2,n3,FFTW_ESTIMATE
*         endif
*     endif


      xmapC(:,:,:) = cmplx(0.0,0.0)
!     work1(:) = 0.0                            ! gianluca 13/01/2010
!     work2(:) = 0.0                            ! gianluca 13/01/2010

      if (jpatt == 0) then
          do i=1,numbrefl
             fourcoef = fop(i)
             phase=dtor*float(iphi2(i))
             work1(i)=fourcoef*sin(phase)
             work2(i)=fourcoef*cos(phase)
*            write(6,*) i, fop(i),iphi2(i)
          enddo
      else
          do i=1,numbrefl
             work1(i) = 0.0                            ! gianluca 13/01/2010
             work2(i) = fop(i)
          enddo
      endif

      twopim = -twopi
      do jn=1, numbrefl
         eep     = work1(jn)
         ee      = work2(jn)
         fh      = cmplx(ee, eep)
         do j=1, nsym
            do l=1,3
               i2(l) = khl(1,jn) * kmat(j,1,l)
     *               + khl(2,jn) * kmat(j,2,l)
     *               + khl(3,jn) * kmat(j,3,l)
            enddo
            phase1 = khl(1,jn) * tmat(j,1)
     +             + khl(2,jn) * tmat(j,2)
     +             + khl(3,jn) * tmat(j,3)

            phase = twopim * phase1
            fm = fh * phasec(phase)
*           write(6,*) i2,ee,eep,phase1
            if (i2(1) >= 0) then
                ih = lmod(i2(1),n0)
                ik = lmod(i2(2),n2)
                il = lmod(i2(3),n3)
                xmapC(ih,ik,il) = conjg(fm)
            endif
            if (-i2(1) >= 0) then
                ih = lmod(-i2(1),n0)
                ik = lmod(-i2(2),n2)
                il = lmod(-i2(3),n3)
                xmapC(ih,ik,il) = fm
            endif
         enddo
      enddo

      xmapC(0,0,0) = cmplx(f000, 0.0)

!!gpu call sfftw_execute(FORTHi)
      call sfftw_executec2r(n1,n2,n3,FORTHi,xmapC,x)
!C!        fftwf_execute(*p)

      return
      end
*----------------------------------------------------------------------------*
      subroutine NonUsataNewInv(iphi2,fop2,numbMax,n1,n2,n3,BACKi)
 
      USE General
      USE Symmetry
      USE Riflessi, only : khl,mkang,wt
      USE Mappa
      USE PhaseModule
      USE Param

      integer*8    ::BACKi
      dimension iphi2(nreflDim),fop2(nreflDim)

 
      integer i1(3),i2(3),lmod
      real phaseof
      complex sf,phasec
      logical hemiFFTW
      external hemiFFTW,lmod,phasec,phaseof
      
      n0 = n1 / 2 + 1
*---- Scale ----*
      scfft1 = 1.0/ real(n1 * n2 * n3 * nsym)

!!gpu call sfftw_execute(BACKi)
!!mr per gpu
      if(BACKi == BACKenv) then
         call sfftw_executer2c(n1,n2,n3,BACKi,xenve,xmapC)
      else
         call sfftw_executer2c(n1,n2,n3,BACKi,xmap,xmapC)
      endif
*---- Fill the reflection list ----*
      do 200 i=1,numbMax
         i1(1:3)=khl(1:3,i)
         wt(i) = 0.0
*---- Average over symmetry equivalents for this reflection ----*
         sf=cmplx(0.0,0.0)

         do j=1,nsym

            do l=1,3
               i2(l)=0
               do k=1,3
                  i2(l)=i2(l)+i1(k)*kmat(j,k,l)
               enddo
            enddo


            phim=twopi*(i1(1)*tmat(j,1)+i1(2)*tmat(j,2)
     *                 +i1(3)*tmat(j,3))

            if (hemiFFTW(i2(1),i2(2),i2(3))) then
               iu = lmod(i2(1),n0)
               iv = lmod(i2(2),n2)
               iw = lmod(i2(3),n3)
               sf = sf + conjg(xmapC(iu,iv,iw)) * phasec(phim)
            else
               iu = lmod(-i2(1),n0)
               iv = lmod(-i2(2),n2)
               iw = lmod(-i2(3),n3)
               sf = sf + xmapC(iu,iv,iw) * phasec(phim)
            endif
         enddo

         sf=sf*scfft1
         fop2(i)=abs(sf)   ! F.d.S calc.
         faze=phaseof(sf)*rtod
         if (mkang(i).ne.1.and.nsym.ne.1) then
             faze1= favi(mkang(i),faze)
             faze=faze1
         endif
         faze=mod(faze+3600.,360.)
         iphi2(i)=faze   ! la fase calc.
         if (QualePgm == 2 .or. kmad /= 0 .or. ifDsrVLD /= 0) then
cG       if (QualePgm == 2 .or. kmad /= 0) then
             wt(i) = 1.0    ! dritan : non cancellare, (serve per il sirprot)
         endif
c        write(1,'(3i4,5f10.2,2x,i4)')i1,fovet(i),sigmav(i),fcvet(i),
c    *                      float(ipub(i)),float(iphaz(i)),mkang(i)
200   continue

      return
      end
*----------------------------------------------------------------------------*
      subroutine NewInvCuda(iphi2,fop2,numbMax,n1,n2,n3,BACKi,x)
 
      USE General
      USE Symmetry
      USE Riflessi, only : khl,mkang,wt
      USE Mappa
      USE PhaseModule
      USE Param

      integer*8    ::BACKi
      dimension iphi2(nreflDim),fop2(nreflDim)
      real         :: x(*)
 
      integer i1(3),i2(3),lmod
      real phaseof
      complex sf,phasec
      logical hemiFFTW
      external hemiFFTW,lmod,phasec,phaseof
      
      n0 = n1 / 2 + 1
*---- Scale ----*
      scfft1 = 1.0/ real(n1 * n2 * n3 * nsym)

!!gpu call sfftw_execute(BACKi)
!!mr per gpu
      call sfftw_executer2c(n1,n2,n3,BACKi,x,xmapC)
*---- Fill the reflection list ----*
      do 200 i=1,numbMax
         i1(1:3)=khl(1:3,i)
         wt(i) = 0.0
*---- Average over symmetry equivalents for this reflection ----*
         sf=cmplx(0.0,0.0)

         do j=1,nsym

            do l=1,3
               i2(l)=0
               do k=1,3
                  i2(l)=i2(l)+i1(k)*kmat(j,k,l)
               enddo
            enddo


            phim=twopi*(i1(1)*tmat(j,1)+i1(2)*tmat(j,2)
     *                 +i1(3)*tmat(j,3))

            if (hemiFFTW(i2(1),i2(2),i2(3))) then
               iu = lmod(i2(1),n0)
               iv = lmod(i2(2),n2)
               iw = lmod(i2(3),n3)
               sf = sf + conjg(xmapC(iu,iv,iw)) * phasec(phim)
            else
               iu = lmod(-i2(1),n0)
               iv = lmod(-i2(2),n2)
               iw = lmod(-i2(3),n3)
               sf = sf + xmapC(iu,iv,iw) * phasec(phim)
            endif
         enddo

         sf=sf*scfft1
         fop2(i)=abs(sf)   ! F.d.S calc.
         faze=phaseof(sf)*rtod
         if (mkang(i).ne.1.and.nsym.ne.1) then
             faze1= favi(mkang(i),faze)
             faze=faze1
         endif
         faze=mod(faze+3600.,360.)
         iphi2(i)=faze   ! la fase calc.
         if (QualePgm == 2 .or. kmad /= 0 .or. ifDsrVLD /= 0) then
cG       if (QualePgm == 2 .or. kmad /= 0) then
             wt(i) = 1.0    ! dritan : non cancellare, (serve per il sirprot)
         endif
c        write(1,'(3i4,5f10.2,2x,i4)')i1,fovet(i),sigmav(i),fcvet(i),
c    *                      float(ipub(i)),float(iphaz(i)),mkang(i)
200   continue

      return
      end
*----------------------------------------------------------------------------*
      subroutine NUNewInvNew(iphi2, fop2, numbMax, n1, n2, n3, BACKi)
 
      USE General
      USE Symmetry
      USE Riflessi, only : khl, mkang, wt
      USE Mappa
      USE PhaseModule
      USE Param

      implicit none
      integer*8   :: BACKi
      integer     :: iphi2(nreflDim), n0, n1, n2, n3, i2(3), lmod
      integer     :: i, j, l, numbMax, iu, iv, iw
      real        :: fop2(nreflDim), phaseof, scfft1, phim, faze1, faze
      real        :: favi
      complex     :: sf, phasec
      logical     :: hemiFFTW
      external    :: hemiFFTW, lmod, phasec, phaseof
      
      n0 = n1 / 2 + 1
*---- Scale ----*
      scfft1 = 1.0/ real(n1 * n2 * n3 * nsym)

!!gpu call sfftw_execute(BACKi)
      call sfftw_executer2c(n1,n2,n3,BACKi,xmap,xmapC)
*---- Fill the reflection list ----*
      do i=1,numbMax
         wt(i) = 0.0
*---- Average over symmetry equivalents for this reflection ----*
         sf=cmplx(0.0,0.0)

         do j=1,nsym
            do l=1,3
               i2(l) = khl(1,i) * kmat(j,1,l)
     *               + khl(2,i) * kmat(j,2,l)
     *               + khl(3,i) * kmat(j,3,l)
            enddo


            phim = twopi * ( khl(1,i) * tmat(j,1)
     *                     + khl(2,i) * tmat(j,2)
     *                     + khl(3,i) * tmat(j,3) )

            if (hemiFFTW(i2(1),i2(2),i2(3))) then
               iu = lmod(i2(1),n0)
               iv = lmod(i2(2),n2)
               iw = lmod(i2(3),n3)
               sf = sf + conjg(xmapC(iu,iv,iw)) * phasec(phim)
            else
               iu = lmod(-i2(1),n0)
               iv = lmod(-i2(2),n2)
               iw = lmod(-i2(3),n3)
               sf = sf + xmapC(iu,iv,iw) * phasec(phim)
            endif
         enddo

         sf=sf*scfft1
         fop2(i)=abs(sf)   ! F.d.S calc.
         faze=phaseof(sf)*rtod
         if (mkang(i).ne.1.and.nsym.ne.1) then
             faze1= favi(mkang(i),faze)
             faze=faze1
         endif
         faze=mod(faze+3600.,360.)
         iphi2(i)=faze   ! la fase calc.
         if (QualePgm == 2 .or. kmad /= 0) wt(i) = 1.0    ! dritan : non cancellare, (serve per il sirprot)
      enddo

      return
      end
*----------------------------------------
      integer function lmod(i,j)
c fixed integer mod (optimised for 0<=i<j)
      integer i,j,k
c
      if (i.lt.0) then
       lmod=mod(i+1,j)+j-1
      else if (i.ge.j) then
       lmod=mod(i,j)
      else
       lmod=i
      endif

      return
      end
c
c ----------------------------------------------------------------------
c
      complex function phasec(phi)
c PHASE - calculate a complex phase factor
      real phi
c
      phasec=cmplx(cos(phi),sin(phi))
      return
      end
!-----------------------------------------------------------------------
      real function phaseof(f)

      complex f

      if (abs(f).gt.0.0000001) then
         phaseof=atan2(aimag(f),real(f))
      else
         phaseof=0.0
      endif

      return
      end
!-----------------------------------------------------------------------
      logical function hemiFFTW(ih,ik,il)

      hemiFFTW=(ih.gt.0 .or.
     +         (ih.eq.0 .and. (il.gt.0 .or.
     +         (il.eq.0 .and. ik.gt.0) ) ) )
      return
      end
!-----------------------------------------------------------------------
      subroutine DistruggiPianiAll
      USE Mappa
      USE EnvelopeModule
!
      if (FORTH /= 0) then
          call sfftw_destroy_plan(FORTH)
          call sfftw_destroy_plan(BACK)
      endif
      if (FORTHenv /= 0) then
          call sfftw_destroy_plan(FORTHenv)
          call sfftw_destroy_plan(BACKenv)
      endif
      if (FORTHdif /= 0) then
          call sfftw_destroy_plan(FORTHdif)
          call sfftw_destroy_plan(BACKdif)
      endif
      FORTH  = 0
      BACK   = 0
      FORTHenv = 0
      BACKenv  = 0
      FORTHdif = 0
      BACKdif  = 0
!
****  if (allocated(xmap)) then
****      xmap(:,:,:) = 0.0
****  endif
****  if (allocated(xenve)) then
****      xenve(:,:,:) = 0.0
****  endif
****  if (allocated(xmapC)) then
****      xmapC(:,:,:) = cmplx(0.0,0.0)
****  endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DistruggiPiani(FORTHi,BACKi)
!
      integer*8    :: FORTHi,BACKi

      if (FORTHi /= 0) then
          call sfftw_destroy_plan(FORTHi)
          call sfftw_destroy_plan(BACKi)
      endif
      FORTHi = 0
      BACKi  = 0
!
      return
      end
*------------------------------------------------------------------*
      subroutine ChangeMapFlex (x,x1,sog,jflagM,jflagE)

      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      common/puntic/npu1,npu2,npu3,npu4

      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))
 
      SOGmin=0.32*volume
      SOGmax=2.0*volume
      nx=np(1)
      ny=np(2)
      nz=np(3)
      n_p=0
c     write(0,*) 'den_p',den_p

      do 150 i=1,nx
         do 100 j=1,ny
            do 50 k=1,nz
               xx=x(i,j,k)
               if (jflagE.gt.0) xx1=x1(i,j,k)/100.0
               if (sog.gt.0.0.and.x(i,j,k).gt.sog) then
                    x(j,i,k)=sog
                    npu1=npu1+1
               endif

               if (jflagM.eq.1) then
*----------------
                  if (xx.lt.den_p.or.xx.le.0.0) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                     if (jflagE.gt.0) then
                         if (xx1.eq.1.0) then
                             npu2=npu2+1
                         elseif (xx1.eq.0.5) then
                             npu3=npu3+1
                         else
                             npu4=npu4+1
                         endif
                     endif
                  endif
*----------------
               elseif (jflagM.eq.11) then
                  if (abs(xx).lt.den_p) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                     if (jflagE.gt.0) then
                         if (xx1.eq.1.0) then
                             npu2=npu2+1
                         elseif (xx1.eq.0.5) then
                             npu3=npu3+1
                         else
                             npu4=npu4+1
                         endif
                     endif
                  endif
*----------------
               elseif (jflagM.eq.2) then
                  if ( xx.le.0.0 ) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                     if (jflagE.gt.0) then
                         if (xx1.gt.0.0.and.xx1.lt.2.0) then
                             if (xx1.eq.1.0) then
                                npu2=npu2+1
                             elseif (xx1.eq.0.5) then
                                npu3=npu3+1
                             else
                                npu4=npu4+1
                             endif 
                         endif
                     endif
                  endif
*----------------
               elseif (jflagM.eq.3) then
                  if ( xx.lt.den_s ) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                  endif
*----------------
               elseif (jflagM.eq.4) then
                  if ( xx.lt.SOGmin ) then
                     x(i,j,k)=SOGmin
                  elseif ( xx.gt.SOGmax ) then
                     x(i,j,k)=SOGmax
                     n_p=n_p+1
                  endif
*----------------
               elseif (jflagM.eq.5) then
                  if (xx1.eq.1.0) then
                     if (xx.lt.den_p) then
                        x(i,j,k)=0.0
                        n_s=n_s+1
                     else
                        n_p=n_p+1
                        npu2=npu2+1
                     endif
                  else
                     if (xx.lt.den_s) then
                         x(i,j,k)=0.0
                         n_s=n_s+1
                     else
                        n_p=n_p+1
                        npu3=npu3+1
                     endif
                  endif
*----------------
               elseif (jflagM.eq.7) then
                     if (xx.gt.den_n.and.xx.lt.den_p) then
                        x(i,j,k)=0.0
                     else
                        if (xx < den_n) n_s=n_s+1
                        if (xx > den_p) n_p=n_p+1
                        if (jflagE.gt.0) then
                           if (xx1.eq.1.0) then
                              npu2=npu2+1
                           elseif (xx1.eq.0.5) then
                              npu3=npu3+1
                           else
                              npu4=npu4+1
                           endif
                        endif
                     endif
*----------------
               else
                  n_p=n_p+1
                  if (jflagE.gt.0) then
                     if (xx1.eq.1.0) then
                        npu2=npu2+1
                     elseif (xx1.eq.0.5) then
                        npu3=npu3+1
                     else
                        npu4=npu4+1
                     endif
                  endif
               endif
  50        continue
 100     continue
 150  continue

      return
      end
c-----------------------------------------
      subroutine rhostats(map,solmsk,strTitolo)

      USE General
      USE Mappa
      USE PhaseModule
      USE Param
c
      character (len=*) :: strTitolo

      real rhomin_loc,rhomax_loc,pmin,pmaxx
      parameter (nhist_loc=100,rhomin_loc=-5.0,rhomax_loc=20.0
     *          ,pmin=-0.9,pmaxx=2.4)
      integer hist_loc(nhist_loc,-10:10)
      integer i,j,k,l,n,ih,imin,imax,nr(-10:10)
      real s(-10:10),s2(-10:10),rmax(-10:10),rmin(-10:10),rho
      real map(np(1),np(2),np(3))
      real solmsk(np(1),np(2),np(3))

      nww=np(3)
      nv=np(2)
      nu=np(1)

      do 20 i=-10,10
       nr(i)=0
       s(i)=0.0
       s2(i)=0.0
       rmin(i)= 1000.0
       rmax(i)=-1000.0
       do 10 j=1,nhist_loc
        hist_loc(j,i)=0
 10    continue
 20   continue

      denmin=1.0e25
      denmax=-1.0e25
      avden=0.0
      stden=0.0 
      call maxminG(0,nu,nv,nww,denmin,denmax,avden,stden,map)
      rhomin_loc1 = denmin /volume
      rhomax_loc1 = denmax /volume
      rhomin_loc1 = rhomin_loc
      rhomax_loc1 = rhomax_loc
      
      do 100 k=1,nww
      do 100 j=1,nv
      do 100 i=1,nu
       rho=map(i,j,k)/volume
       ih=int(nhist_loc*(rho-rhomin_loc1)/(rhomax_loc1-rhomin_loc1))
       ih=max(min(ih,nhist_loc),1)
       ia=int(solmsk(i,j,k))
       l=int(ia/100)
       nr(l)=nr(l)+1
       s(l)=s(l)+rho
       s2(l)=s2(l)+rho**2
       rmax(l)=max(rmax(l),rho)
       rmin(l)=min(rmin(l),rho)
       hist_loc(ih,l)=hist_loc(ih,l)+1
 100  continue

      n=nu*nv*nww
      write (lo,'(10x,a)') trim(strTitolo)
      write (lo,'(5x,a)') '==========================='
      write (lo,200)
      write(lo,*)'rho(Prot/Tot)',s2(1)/(s2(0)+s2(1))
      write(lo,*)'rho(Solv/Tot)',s2(0)/(s2(0)+s2(1))
      write (lo,201)'Protein',(100.0*nr(1))/n,rmin(1),rmax(1),
     +  s(1)/nr(1),sqrt(max(s2(1)*nr(1)-s(1)**2,0.0))/nr(1)
      write (lo,201)'Solvent',(100.0*nr(0))/n,rmin(0),rmax(0),
     +  s(0)/nr(0),sqrt(max(s2(0)*nr(0)-s(0)**2,0.0))/nr(0)
      if (nr(-1).ne.0) write (lo,201)'Unknown',(100.0*nr(-1))/n,
     +  rmin(-1),rmax(-1),s(-1)/nr(-1),
     +  sqrt(max(s2(-1)*nr(-1)-s(-1)**2,0.0))/nr(-1)
 200  format(/9x,'% of cell   Min Rho   Max Rho   Mean Rho   Std.Dev.')
 201  format(1x,a7,': ',f8.1,'  ',f8.3,'  ',f8.3,'   ',f8.3,'   ',f8.3)
      imin=int(nhist_loc*(pmin-rhomin_loc1)/(rhomax_loc1-rhomin_loc1))
      imax=int(nhist_loc*(pmaxx-rhomin_loc1)/(rhomax_loc1-rhomin_loc1))
      write (lo,205)
 205  format (/' Density       Number of counts:   Number of counts:'
     +        /' Range:        (Protein)           (Solvent)')
      do 220 i=imin,imax
      rho=(i+0.5)*(rhomax_loc1-rhomin_loc1)/nhist_loc+rhomin_loc1
      write (lo,210)rho,hist_loc(i,1),hist_loc(i,0)
 210  format(1x,f8.3,8x,i10,10x,i10)
 220  continue

      write (lo,*)

      return
      end
c------------------------------------------------------------------
      subroutine denhist(iflagDen,x,x1,npts_p,npts_n)

      USE General
      USE Mappa
c     USE PhaseModule
      USE Param

      real hispP(501),hispS(501),hispL(501)
      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))

      nx=np(1)
      ny=np(2)
      nz=np(3)
      npunti=nx*ny*nz

      denmin=1.0e25
      denmax=-1.0e25
      call maxminG(0,nx,ny,nz,denmin,denmax,avden,stden,x)

      nrange=500
      rang=(denmax - denmin)/nrange
      do 10 i=1,nrange+1
         hispS(i)=0.0
         hispP(i)=0.0
         hispL(i)=0.0
         range(i)=denmin + rang*(i-1)
 10   continue
      nrange=nrange+1

      denminP=1.0e25
      denmaxP=-1.0e25
      denminS=1.0e25
      denmaxS=-1.0e25
      if (iflagDen == 0) then
        denminS=0.0
        denmaxS=0.0
      endif
      avdenP= 0.0
      stdenP=0.0
      rpuntiP=0.0
      avdenS= 0.0
      stdenS=0.0
      rpuntiS=0.0
      do 150 ky=1,ny
         do 100 kz=1,nz
           do 50 kx=1,nx
               xx=x(kx,ky,kz)
               xx1=x1(kx,ky,kz)/100.0
               n=int((xx-denmin)/rang) + 1
               if (n.gt.nrange) n=nrange
               if (n.le.1) n=1
               if (iflagDen.eq.1) then
                  if (xx1.eq.1.0) then
                     hispP(n)=hispP(n)+1.0
                     avdenP=avdenP + xx
                     stdenP=stdenP + xx * xx
                     rpuntiP=rpuntiP +1
                     denmaxP=max(xx,denmaxP)
                     denminP=min(xx,denminP)
                  else
                     hispS(n)=hispS(n)+1.0
                     avdenS=avdenS + xx
                     stdenS=stdenS + xx * xx
                     rpuntiS=rpuntiS +1
                     denmaxS=max(xx,denmaxS)
                     denminS=min(xx,denminS)
                  endif
               else
                  hispP(n)=hispP(n)+1.0
                  avdenP=avdenP + xx
                  stdenP=stdenP + xx * xx
                  rpuntiP=rpuntiP +1
                  denmaxP=max(xx,denmaxP)
                  denminP=min(xx,denminP)
               endif

               hispL(n)=hispL(n)+1.0

 50         continue
 100     continue

 150  continue

*     if (kverbo==4) then
      if (kverbo > 0) then
      write(lo,*)
      write(lo,*)'  ***************************************'
      write(lo,*)'  *           HISTOGRAM MAP             *'
      write(lo,*)'  ***************************************'
      write(lo,*)

      avdenP=avdenP/rpuntiP
      stdenP=stdenP/rpuntiP - avdenP*avdenP
      if (stdenP.gt.0.0) then
          stdenP=sqrt(stdenP)
      else
          stdenP=0.0
      endif

      if (rpuntiS > 0.0) then
       avdenS=avdenS/rpuntiS
       stdenS=stdenS/rpuntiS - avdenS*avdenS
       if (stdenS.gt.0.0) then
          stdenS=sqrt(stdenS)
       else
          stdenS=0.0
       endif
      endif

      write (lo,2000)
      write (lo,2100)'Protein',(100.0*rpuntiP)/(rpuntiP+rpuntiS),
     *  denminP/volume,denmaxP/volume,avdenP/volume,stdenP/volume
      write (lo,2100)'Solvent',(100.0*rpuntiS)/(rpuntiP+rpuntiS),
     *  denminS/volume,denmaxS/volume,avdenS/volume,stdenS/volume

      write(lo,*)
      write(lo,*) '    Range      Points(Protein)  Points(solvent)'
      nstep=25
      num=hispP(1)
      num1=hispS(1)
      ico=1
      do 200 i=1,nrange,nstep
         ic=i
         if (i.gt.1) then
           num=0
           num1=0
           do ii=ico,ic
              num=num+ hispP(ii)
              num1=num1+ hispS(ii)
           enddo
         endif
         write(lo,1000) range(i)/volume,num,num1
      ico=ic
 200  continue
 1000 format(f10.3,i12,5x,i12)
      write(lo,*)
      endif

      if (npts_p > 0.0) then
        jflag=1
        npts1=npts_p
        call findsog(hispL,den_p,npts1,jflag)
        npts1=nint(npunti*v_p)
        call findsog(hispL,den_s,npts1,jflag)
      endif
c     if (invflag.eq.3) then
      if (npts_n > 0.0) then
          jflag=2
          npts1=npts_n                   ! % di punti della mappa negativa
          call findsog(hispL,den_n,npts1,jflag)
      endif


 2000 format(/9x,'% of cell   Min Rho   Max Rho   Mean Rho   Std.Dev.')
 2100  format(1x,a7,': ',f8.1,'  ',f8.3,'  ',f8.3,'   ',f8.3,'   ',f8.3)


c     write(lo,*)'protein:', denmaxP/volume,denminP/volume,
c    *             rpuntiP/(rpuntiP+rpuntiS),
c    *             avdenP/volume,stdenP/volume
c     write(lo,*)'solvent:',denmaxS/volume,denminS/volume,
c    *             rpuntiS/(rpuntiP+rpuntiS),
c    *             avdenS/volume,stdenS/volume

c     write(lo,3000) denmax/volume,denmin/volume,avden/volume,
c    +             stden/volume,den_p/volume,den_s/volume
c3000 format('   Maximum density ............ ',f8.3,/,
c    +       '   Minimum density ............ ',f8.3,/,
c    +       '   Average density ............ ',f8.3,/,
c    +       '   Standar deviation .......... ',f8.3,/,
c    +       '   Level protein ...... ........',f8.3,/,
c    +       '   Level solvent ...............',f8.3,/)
      
      return
      end

c------------------------------------------------------------------
      subroutine denhistNew(iflagDen,x,x1,npts_p,npts_n)

      USE General
      USE Mappa
c     USE PhaseModule
      USE Param

      real hispP(501),hispS(501),hispL(501)
      common /locale/ hispP, hispS, hispL
      real  x(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      real x1(0:np(1)-1,0:np(2)-1,0:np(3)-1)

      nx=np(1)
      ny=np(2)
      nz=np(3)
      npunti=nx*ny*nz

      denmin=1.0e25
      denmax=-1.0e25
      call maxminG(0,nx,ny,nz,denmin,denmax,avden,stden,x)
      write(6,*) 'denhist',denmin,denmax,avden,stden

      nrange=500
      rang=(denmax - denmin)/nrange
      do 10 i=1,nrange+1
         hispS(i)=0.0
         hispP(i)=0.0
         hispL(i)=0.0
         range(i)=denmin + rang*(i-1)
 10   continue
      nrange=nrange+1

      denminP=1.0e25
      denmaxP=-1.0e25
      denminS=1.0e25
      denmaxS=-1.0e25
      if (iflagDen == 0) then
        denminS=0.0
        denmaxS=0.0
      endif
      avdenP= 0.0
      stdenP=0.0
      rpuntiP=0.0
      avdenS= 0.0
      stdenS=0.0
      rpuntiS=0.0
      do 150 ky=0,ny-1
         do 100 kz=0,nz-1
           do 50 kx=0,nx-1
               xx=x(kx,ky,kz)
               xx1=x1(kx,ky,kz)/100.0
               n=int((xx-denmin)/rang) + 1
               if (n.gt.nrange) n=nrange
               if (n.le.1) n=1
               if (iflagDen.eq.1) then
                  if (xx1.eq.1.0) then
                     hispP(n)=hispP(n)+1.0
                     avdenP=avdenP + xx
                     stdenP=stdenP + xx * xx
                     rpuntiP=rpuntiP +1
                     denmaxP=max(xx,denmaxP)
                     denminP=min(xx,denminP)
                  else
                     hispS(n)=hispS(n)+1.0
                     avdenS=avdenS + xx
                     stdenS=stdenS + xx * xx
                     rpuntiS=rpuntiS +1
                     denmaxS=max(xx,denmaxS)
                     denminS=min(xx,denminS)
                  endif
               else
                  hispP(n)=hispP(n)+1.0
                  avdenP=avdenP + xx
                  stdenP=stdenP + xx * xx
                  rpuntiP=rpuntiP +1
                  denmaxP=max(xx,denmaxP)
                  denminP=min(xx,denminP)
               endif

               hispL(n)=hispL(n)+1.0

 50         continue
 100     continue

 150  continue

      if (kverbo > 0) then
          write(lo,*)
          write(lo,*)'  ***************************************'
          write(lo,*)'  *           HISTOGRAM MAP             *'
          write(lo,*)'  ***************************************'
          write(lo,*)

          avdenP=avdenP/rpuntiP
          stdenP=stdenP/rpuntiP - avdenP*avdenP
          if (stdenP.gt.0.0) then
              stdenP=sqrt(stdenP)
          else
              stdenP=0.0
          endif

          if (rpuntiS > 0.0) then
              avdenS=avdenS/rpuntiS
              stdenS=stdenS/rpuntiS - avdenS*avdenS
              if (stdenS.gt.0.0) then
                  stdenS=sqrt(stdenS)
              else
                  stdenS=0.0
              endif
          endif

          write (lo,2000)
          write (lo,2100)'Protein',(100.0*rpuntiP)/(rpuntiP+rpuntiS),
     *      denminP/volume,denmaxP/volume,avdenP/volume,stdenP/volume
          write (lo,2100)'Solvent',(100.0*rpuntiS)/(rpuntiP+rpuntiS),
     *      denminS/volume,denmaxS/volume,avdenS/volume,stdenS/volume

          write(lo,*)
          write(lo,*) '    Range      Points(Protein)  Points(solvent)'
          nstep=25
          num=hispP(1)
          num1=hispS(1)
          ico=1
          do 200 i=1,nrange,nstep
             ic=i
             if (i.gt.1) then
               num=0
               num1=0
               do ii=ico,ic
                  num=num+ hispP(ii)
                  num1=num1+ hispS(ii)
               enddo
             endif
             write(lo,1000) range(i)/volume,num,num1
          ico=ic
 200      continue
 1000     format(f10.3,i12,5x,i12)
          write(lo,*)
      endif

      if (npts_p > 0.0) then
        jflag=1
        npts1=npts_p
        call findsog(hispL,den_p,npts1,jflag)
        npts1=nint(npunti*v_p)
        call findsog(hispL,den_s,npts1,jflag)
      endif
c     if (invflag.eq.3) then
      if (npts_n > 0.0) then
          jflag=2
          npts1=npts_n                   ! % di punti della mappa negativa
          call findsog(hispL,den_n,npts1,jflag)
      endif


 2000 format(/9x,'% of cell   Min Rho   Max Rho   Mean Rho   Std.Dev.')
 2100 format(1x,a7,': ',f8.1,'  ',f8.3,'  ',f8.3,'   ',f8.3,'   ',f8.3)

      if (kverbo == 4) then
          write(lo,*)'protein:', denmaxP/volume,denminP/volume,
     *                 rpuntiP/(rpuntiP+rpuntiS),
     *                 avdenP/volume,stdenP/volume
          write(lo,*)'solvent:',denmaxS/volume,denminS/volume,
     *                 rpuntiS/(rpuntiP+rpuntiS),
     *                 avdenS/volume,stdenS/volume

          write(lo,3000) denmax/volume,denmin/volume,avden/volume,
     +                 stden/volume,den_p/volume,den_s/volume
 3000     format('   Maximum density ............ ',f8.3,/,
     +           '   Minimum density ............ ',f8.3,/,
     +           '   Average density ............ ',f8.3,/,
     +           '   Standar deviation .......... ',f8.3,/,
     +           '   Level protein ...... ........',f8.3,/,
     +           '   Level solvent ...............',f8.3,/)
      endif
!
      return
      end

*----------------------------------------------*
      subroutine findsog(hispL,sogden,npts1,jflagSog)

c     USE General
      USE Param
      dimension hispL(501)

      rang=(denmax - denmin)/nrange
      if (jflagSog.eq.1) then
         ires=0
         do i=nrange+1,2,-1
            ires=ires+hispL(i-1)
            if (ires.ge.npts1) then
               sogden = denmin + (rang*(i-2) + rang/2)
               exit
            endif
         enddo
      elseif (jflagSog.eq.2) then
         ires=0
         do i=2,nrange+1
            ires=ires+hispL(i-1)
            if (ires.ge.npts1) then
               sogden = denmin + (rang*(i-2) + rang/2)
               exit
            endif
         enddo
      elseif (jflagSog.lt.0) then                ! uso una soglia predefinita (sogden)
         ires=0
         res=0.0
         do i=nrange+1,2,-1
            res=range(i-1)
            ies=ires + hispL(i-1)
            if (res.le.sogden) then
               npts=ires
               exit
            endif
         enddo
      endif
!     write(6,40) npts1,jflag,nrange,perc,denmin,denmax,sogden
! 40  format('BBBB findsog',i15,2i4,4f12.3)


      return
      end
*----------------------------------------------------------------------------*
      subroutine maxminG(id,nx,ny,nz,denmin,denmax,avden,stden,x)
      USE General
      real x(1:nx,1:ny,1:nz)

!     id = 0 tutta la mappa
!     id = 1 la parte positiva della mappa

      avden = 0.0
      stden = 0.0
      denmin = 1.0e25
      denmax = -1.0e25
      npunt = 0

      if (id ==0) then
         do  iz = 1, nz
          do  iy = 1, ny
           do  ix = 1, nx
              xx=x(ix,iy,iz)
              denmax=amax1(denmax,xx)
              denmin=amin1(denmin,xx)
              avden=avden + xx
              stden=stden + xx * xx
              npunt=npunt+1
           enddo
          enddo
         enddo
      else
         do  iz = 1, nz
          do  iy = 1, ny
           do  ix = 1, nx
              xx=x(ix,iy,iz)
              if (xx > 0.0) then
                denmax=amax1(denmax,xx)
                denmin=amin1(denmin,xx)
                avden=avden + xx
                stden=stden + xx * xx
                npunt=npunt+1
              endif
           enddo
          enddo
         enddo
      endif

      avden=avden/float(npunt)
      stden=stden/float(npunt)
      stden=stden - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif

      return
      end
*----------------------------------------------------------------------------*
      subroutine maxminGNew(id,nx,ny,nz,denmin,denmax,avden,stden,x)
      USE General
      real x(0:nx-1,0:ny-1,0:nz-1)

!     id = 0 tutta la mappa
!     id = 1 la parte positiva della mappa

      avden = 0.0
      stden = 0.0
      denmin = 1.0e25
      denmax = -1.0e25
      npunt = 0

      if (id ==0) then
         do  iz = 0, nz-1
          do  iy = 0, ny-1
           do  ix = 0, nx-1
              xx=x(ix,iy,iz)
              denmax=amax1(denmax,xx)
              denmin=amin1(denmin,xx)
              avden=avden + xx
              stden=stden + xx * xx
              npunt=npunt+1
           enddo
          enddo
         enddo
      else
         do  iz = 0, nz-1
          do  iy = 0, ny-1
           do  ix = 0, nx-1
              xx=x(ix,iy,iz)
              if (xx > 0.0) then
                denmax=amax1(denmax,xx)
                denmin=amin1(denmin,xx)
                avden=avden + xx
                stden=stden + xx * xx
                npunt=npunt+1
              endif
           enddo
          enddo
         enddo
      endif

      avden=avden/float(npunt)
      stden=stden/float(npunt)
      stden=stden - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine mapcorr(x1, x2, corre)
      USE General
      USE Mappa, only : np
     
!
      implicit none
      integer :: nnx, nny, nnz, npunti, ix, iy, iz
      real    :: corre
      real    :: x1(1:np(1),1:np(2),1:np(3))
      real    :: x2(1:np(1),1:np(2),1:np(3))
!
      real*8  :: vmedt, vmedc, vmedtc, vmed2t, vmed2c
      real*8  :: rnum, rden, rden1, rden2, zero
      real*8  :: flpunti, xx1, xx2
!
!--  Correlazione tra due mappe in memoria X1 e X2
!
      zero = 0.0000001
!
      nnx = np(1)
      nny = np(2)
      nnz = np(3)
!
      npunti = 0
      vmedt  = 0.0
      vmedc  = 0.0
      vmedtc = 0.0
      vmed2t = 0.0
      vmed2c = 0.0
!
      do iz=1, nnz
         do iy=1, nny
            do ix=1, nnx
               npunti = npunti+1
               xx1    = x1(ix,iy,iz)
               xx2    = x2(ix,iy,iz)
               vmedt  = vmedt + xx1
               vmedc  = vmedc + xx2
               vmedtc = vmedtc + xx1 * xx2
               vmed2t = vmed2t + xx1 * xx1
               vmed2c = vmed2c + xx2 * xx2
            enddo
         enddo
      enddo
!
      flpunti = npunti
      vmedt   = vmedt/ flpunti
      vmedc   = vmedc/ flpunti
      vmedtc  = vmedtc/ flpunti
      vmed2t  = vmed2t/ flpunti
      vmed2c  = vmed2c/ flpunti
!
      rnum  = vmedtc - (vmedt * vmedc)
      rden1 = (vmed2t - vmedt**2)
      rden2 = (vmed2c - vmedc**2)
!
      if (rden1 < zero .or. rden2 < zero) then
          rden = 0.0
      else
          rden = dsqrt(vmed2t-vmedt**2) * dsqrt(vmed2c-vmedc**2)
      endif
!
      if (rden < zero) then
          corre = 0.0
      else
          corre = rnum / rden
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine mapcorr4(x1,x2,corre)
      USE General
*     USE ParametriMappa
      USE Mappa, only : np
     
c
      real x1(1:np(1),1:np(2),1:np(3))
      real x2(1:np(1),1:np(2),1:np(3))

c     call scrper(' Map correlation calculation',0,0)

C --  Correlazione tra due mappe in memoria X1 e X2

      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      npunti=0
      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0

      do 50 iz=1,nnz
        do 30 iy=1,nny
          do 20 ix=1,nnx
             npunti=npunti+1
             xx1=x1(ix,iy,iz)
             xx2=x2(ix,iy,iz)
             vmedt=vmedt + xx1
             vmedc=vmedc + xx2
             vmedtc=vmedtc + xx1 * xx2
             vmed2t=vmed2t + xx1 * xx1
             vmed2c=vmed2c + xx2 * xx2
 20      continue
 30     continue
 50   continue

      vmedt=vmedt/float(npunti)
      vmedc=vmedc/float(npunti)
      vmedtc=vmedtc/float(npunti)
      vmed2t=vmed2t/float(npunti)
      vmed2c=vmed2c/float(npunti)

      rnum=vmedtc - (vmedt*vmedc)
      rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
      corre=rnum/rden


      return
      end
c------------------------------------------------------------------
      subroutine mapcorrSog(x1,x2,sog,correlation,ier)
     
      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      real x1(1:np(1),1:np(2),1:np(3))
      real x2(1:np(1),1:np(2),1:np(3))

      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      npunti=0
      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0

      do 50 iy=1,nny
        do 30 iz=1,nnz
          do 20 ix=1,nnx
             xx1=x1(ix,iy,iz)
             xx2=x2(ix,iy,iz)
             if (xx1 > sog.and.xx2 > sog) then
              npunti=npunti+1
              vmedt=vmedt + xx1
              vmedc=vmedc + xx2
              vmedtc=vmedtc + xx1 * xx2
              vmed2t=vmed2t + xx1 * xx1
              vmed2c=vmed2c + xx2 * xx2
             endif
 20      continue
 30     continue
 50   continue

      vmedt = vmedt/float(npunti)
      vmedc = vmedc/float(npunti)
      vmedtc = vmedtc/float(npunti)
      vmed2t = vmed2t/float(npunti)
      vmed2c = vmed2c/float(npunti)

      rnum = vmedtc - (vmedt*vmedc)
      aa = vmed2t-vmedt**2
      bb = vmed2c-vmedc**2
      if (aa > 0.0.and.bb > 0.0) then
        rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
        correlation = rnum/rden
      else
        correlation = 0.0
      endif

c     write(lo,25)correlation,npunti
 25   format(4x,'CC Map1-Map2:',f7.4,2x,i6)

      return
      end
*------------------------------------------------------------------*
      function favi(ityp1,phi)

      iphi = nint(phi)
      idv   = 15 * mod(iabs(ityp1)-1, 12)
      ip1   = idv
      ip2   = idv + 180
      idif1 = iabs(iphi-ip1)
      idif1 = min0(idif1, 360-idif1)
      idif2 = iabs(iphi-ip2)
      idif2 = min0(idif2, 360-idif2)
      if (idif2 < idif1) then
          phi = ip2
      else
          phi = ip1
      endif
      if (phi <= 0.01) phi = phi + 360.0
      favi=phi
      return
      end
!-----------------------------------------------------------------------
      subroutine Init_pksrch(dm)
      USE General
      USE Mappa
!
      implicit none
      real      :: ttt, dxmax, dm, dm0, dm_fou
      integer   :: ishift, i, j, k
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
!
      factr= resm / 3.0
!
      if (lproj == 0) then
          dm0 = 0.85   ! limite adatto per una Mappa Fourier
      else
          dm0 = factr  ! limite adatto per una Mappa Fourier 2D
          dm0 = 0.85
      endif
!
      dxmax(1)=dm0*cell(2)*cell(3)*sin(dtor*cell(4))/volume
      dxmax(2)=dm0*cell(3)*cell(1)*sin(dtor*cell(5))/volume
      dxmax(3)=dm0*cell(1)*cell(2)*sin(dtor*cell(6))/volume
      dm=dm0*dm0
      dm_fou = dm
!
!-- set up matrix to calculate distances and angles
!
      do i=4,6
         j=8/i
         k=15/i
         ttt(j,k)=cos(dtor*cell(i))
         ttt(k,j)=ttt(j,k)
      enddo
      do i=1,3
         ttt(i,i)=1.0
         do j=1,3
            ttt(i,j)=ttt(i,j)*cell(i)*cell(j)
         enddo
      enddo
!
!--shifts per peak search
!
      ishift(1:3,1) =(/ -1,  0, -1/)
      ishift(1:3,2) =(/  0, -1, -1/)
      ishift(1:3,3) =(/  0,  0, -1/)
      ishift(1:3,4) =(/  0,  1, -1/)
      ishift(1:3,5) =(/  1,  0, -1/)
      ishift(1:3,6) =(/ -1, -1,  0/)
      ishift(1:3,7) =(/ -1,  0,  0/)
      ishift(1:3,8) =(/ -1,  1,  0/)
      ishift(1:3,9) =(/  0, -1,  0/)
      ishift(1:3,10)=(/  0,  0,  0/)
      ishift(1:3,11)=(/  0,  1,  0/)
      ishift(1:3,12)=(/  1, -1,  0/)
      ishift(1:3,13)=(/  1,  0,  0/)
      ishift(1:3,14)=(/  1,  1,  0/)
      ishift(1:3,15)=(/ -1,  0, +1/)
      ishift(1:3,16)=(/  0, -1, +1/)
      ishift(1:3,17)=(/  0,  0, +1/)
      ishift(1:3,18)=(/  0,  1, +1/)
      ishift(1:3,19)=(/  1,  0, +1/)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine pksrch_New(mode, iflagPKS, numb, ier)
!
!-- find positions of peaks by fitting quadratic function to 19 points
!
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Mappa
      USE PhaseModule
!
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
      real xs(3),xs1(3)
      real xo(11),xn(11)
      real b(19)
      integer sidepp, key(10)
      integer np1(3),np2(3)
!
      xyzs(4,:) = 0
!
      numbsav = numb
      if (krecy.eq.0) then
          if (mode.gt.0) then
              zats=aperc(mode)
              nats = min0(nint(zats), natm)
          else
              if (ifFour > 0.or.mode==-1) then
                  nats = aperc(1)
              else
                  zats=aperc(1)
                  nats = min0(nint(zats), natm)
              endif
          endif
      else
          natmax = nint(float(natm)*1.3)
          if (nats.gt.natmax) nats=natmax
          if (krecy.eq.1) then
              nats = nint(float(natm)*0.7)
          else if (krecy.eq.2) then
              nats = nint(float(natm)*0.9)
          else if (krecy.eq.3) then
              nats = nint(float(natm)*1.1)
          else if (krecy.eq.4) then
              nats = nint(float(natm)*1.1)
          else if (krecy.ge.5) then
               if (natm > 300) then      ! gianluca 18/06/2015
                   nats = nint(float(natm)*1.1)
               else
                   nats = nint(float(natm)*1.2)
               endif
          endif
!
!pgVLD
          if (ifVLD == 1 .and. ksize == 3 .and. natm < 300) then
              nats = nats * 1.1
*             nats = min0(nats, natm)
          endif
!pgVLD
      endif
c
      if (ipreb.gt.0.and.krecy.gt.0) then
         if(mod(krecy,2).eq.1) then
               nats = nint(float(natm)*0.5)
         else if(mod(krecy,2).eq.0) then
               nats = nint(float(natm)*0.6)
         endif
c
      endif  
      nats = min0(MaxAtoms-20, nats)
      if (ksize > 2) then
          if (nats < 20) nats = 20
      else
          if (nats < 5) nats = 5
      endif
      if (neutro == 2) then
*         nats = nats * 4
*         npic = npic * 4
          if (nats < 10) then
              nats = nats * 2
              npic = npic * 2
          endif
      endif
      npic = nint(nats * 1.3)
      npic = min0(MaxAtoms-20, npic)
!
!-- micro structures
!
      if (ksize == 1) then
          if (npic < 10) then
              npic = 10
          endif
          if (nats < 10) then
              nats = 10
          endif
      endif
*     if (neutro == 2) then
*         nats = 2 * nats
*         npic = 2 * npic
*     endif

      call pksrch_core(xmap, np, ifPatt, iflagPKS, npic, dm, 
     *                 NumPeaks, ier)
!
!-- calculate the occupancy
!
!-!   xyzs(4,NumPeaks+1:) = 0
      fnatm=float(natm)
      fnatm=amax1(anat,fnatm)
Corig focct=0.2*anat+anat

      focct=float(nats)   ! dedi 25/3/2010

      if (neutro == 2 .and. nats < 10) then     ! gianluca 06/07/07
          focct= 1.5 * focct
          focct= 1.5 * anat
      endif
      iactn=1
      xo(:) = 0.0
      xn(:) = 0.0
      ifP1 = nsym*(icent+1)
      nats = min0(NumPeaks, nats)
      itype = 0
      sumOcc = 0.0
      jj = 0
      if (neutro == 0) then
          iactn = 1
      else
          iactn = 2
      endif
      do i=1,NumPeaks
         if (ifP1.ne.1) then
             xo(1:3)=xyzs(1:3,i)
             iser=i
             khead=0
             ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
             if (neutro == 2) then
                 xo(1:3) = xn(1:3)
             endif
             occ=1.0/float(key(10))
         else
             occ=1.0
         endif
         xyzs(5,i) = occ
         sumOcc = sumOcc + occ
         if (.not.(sumOcc > focct)) then
             jj = jj + 1
         endif
      enddo
      if (ifFour /= 0) then
          jj = nats
      endif
      if (jj > nats) then
          nats = jj
      endif
!
!-- aggiunta il 12/03/2008 da gianluca
!
!     if (ksize <= 3 .and. neutro == 0) then
      if (ksize <= 3 .and. ifResBias == 0) then ! dedi
          nats = max0(jj, nk)
      endif
      if (neutro == 2 .and. krecy >= 5) nats = nats + 1
!
      nemap = nats
      if (neutro == 0) then
      if (ksize.eq.1) then
          if (nats.lt.10) nats = 10   
      else
          if (nats.lt.5) nats=5
      endif
      endif
      nnumb = 40 * nats
      if (nnumb.gt.nrefB) nnumb = nrefB
      numb = nnumb
      if (krecy.eq.0.or.ipreb.gt.0) numb = numbsav
!
!-- check for intensities <= 0
!
      nats = min0(MaxAtoms, nats)
      jj = 0
      do i=1,nats
         if (xyzs(4,i) > 0.5) then
             jj = i
         else
             exit
         endif
      enddo
      nats = jj
      nats = min0(nats, NumPeaks)
      nats = min0(NumPeaks, nats)
      if (nats > 0) nz(1:nats) = 0

!- dedi 29/04/09   gestione errore 
      if (nats == 0) then
          write(lo,*) ' *** ERROR: No Peaks Found ***'
          ier = -2
          return
      endif
!
      if (kverbo.gt.0) then
          npic=NumPeaks
          write(lo,22) npic,nats,krecy,mode
      endif
*     write(6,*) 'pksrch_New nats:',nats, np, np1, NumPeaks
 22   format ('PKS npic =',i8,' nats =',i8,' krecy =',i4,' mode =',i4)
*     do i=1,nats
*        write(6,'(i5,1h),5f10.3)') i,xyzs(1:5,i)
*     enddo
!
      call DoSingleIteration()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine pksrch_core(xmap, np, ifPatt, iflagPKS, npic, dm, 
     *                       NumPeaks, ier)
      USE General
      USE Symmetry
      USE Atomi
*     USE Mappa
!
      implicit none
      integer   :: np(3)
      real      :: xmap(0:np(1)-1, 0:np(2)-1, 0:np(3)-1)
      real      :: dx, dy, dz, alevel, alimd, alimu, xs(3), deltaxf
      real      :: deltay, deltaz, b1, b2, f, c, d, e, xx, yy, zz
      real      :: side, quadr, xs1(3), ttt, dxmax, dm, b(19)
      integer   :: ifPatt, npic, ier, l, k , NumPeaksAll, ishift
      integer   :: iflagPKS, limit, NumPeaks, np1(3), np2(3), nop1
      integer   :: sidepp
      integer   :: ndown, nup, ix, iy, iz, jx, jy, jz, i, j, ir, jj
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
!
      dx = 1.0/float(np(1))
      dy = 1.0/float(np(2))
      dz = 1.0/float(np(3))
      limit = min0(MaxAtoms, npic)
      alevel = 0.1
      NumPeaks = 0
!
!--eventualmente limito la ricerca
      do i=1,3
        np1(i)=0
        np2(i)=np(i)-1
        if(iflagPKS==0) then
          alimd=xyzfou(i,1)/xyzfou(i,4)
          alimu=xyzfou(i,2)/xyzfou(i,4)
        else
          alimd = 0.0
          alimu = 1.0
        endif
        if(alimd>=0.0) then
          ndown=max0(np1(i),floor(alimd*np(i)))
          nup=min(np2(i),ceiling(alimu*np(i)))
          np1(i)=ndown
          np2(i)=nup
        endif
      enddo
!     write(6,*) 'occhio',np,np1,np2
!
!--initialise variables
      do iz=np1(3),np2(3)
       do iy=np1(2),np2(2)
        do_ix: do ix=np1(1),np2(1)
            b(10)=xmap(ix,iy,iz)
            if (b(10) < alevel) cycle
!--locate grid point with maximum density
            do i=1,19
              if(i==10) cycle
              jx = sidepp(ix+ishift(1,i),np(1))
              jy = sidepp(iy+ishift(2,i),np(2))  
              jz = sidepp(iz+ishift(3,i),np(3))
              b(i)=xmap(jx,jy,jz)
              if (b(10) <  b(i)) then
                  if (QualePgm /= JAVPGM) then
                      cycle do_ix
                  endif
              elseif (b(10) == b(i)) then
c--scarto il picco solo se ho gia' preso uno vicino 
                do j=1,NumPeaks
                   if(jx==nint(xyzs(1,j)*np(1)).and.
     &                jy==nint(xyzs(2,j)*np(2)).and.
     &                jz==nint(xyzs(3,j)*np(3))) then
                      cycle do_ix
                   endif
                enddo
              endif
            enddo
c--check if the peak is inside the asymmetric unit
            xs(1) = float(ix) * dx
            xs(2) = float(iy) * dy
            xs(3) = float(iz) * dz
c-- fit quadratic function to 19 points
c-- dens = a + c*x + d*y + e*z - 0.5*f*(x*x + y*y + z*z)
            b1 = b(3) + b(7) + b(9) + b(11) + b(13) + b(17)
            b2 = b(1) + b(2) + b(4) + b(5) + b(6) + b(8) + 
     &           b(12) + b(14) +  b(15) + b(16) + b(18) + b(19)
            f = (30.0 * b(10) + 11.0 * b1 - 8.0 * b2) / 63.0
            if(abs(f)>=0.001) then
              c = (b(5)+b(12)+b(13)+b(14)+b(19)
     &            -b(1)-b(6)-b(7)-b(8)-b(15))/10.0
              deltaxf = c / f
              if(abs(deltaxf)<1.0) then
                d = (b(4)+b(8)+b(11)+b(14)+b(18)
     &              -b(2)-b(6)-b(9)-b(12)-b(16))/10.0
                deltay = d / f
                if(abs(deltay)<1.0) then
                  e = (b(15)+b(16)+b(17)+b(18)+b(19)
     &                -b(1)-b(2)-b(3)-b(4)-b(5))/10.0
                  deltaz = e / f
                  if(abs(deltaz)<1.0) then
                    xs(1) = xs(1) + deltaxf * dx
                    xs(2) = xs(2) + deltay * dy
                    xs(3) = xs(3) + deltaz * dz
                  endif
                endif
              endif
            endif
c-- peak height interpolation - not suitable if peak shape is poor
c-- a = (9.0 * b(10) + 4.0 * b1 - b2) / 21.0
c-- b(10) = amax1(a+0.5*(c*deltaxf+d*deltay+e*deltaz), b(10))
            nop1 = NumPeaks+1
            xx=side(xs(1))
            yy=side(xs(2))
            zz=side(xs(3))
            xyzs(1,nop1) = xx
            xyzs(2,nop1) = yy
            xyzs(3,nop1) = zz
            xyzs(4,nop1) = b(10)
c--if two peaks are closer than dm angstroms eliminate the smaller
            if(NumPeaks > 0) then
             ir=0
             do k=1,nsymTot
               call oper(k,xs,xx,yy,zz)
               if (lproj > 0) xs(lproj) = 0.0
               do_pk: do jj=1,NumPeaks
                  do l=1,3
                    xs1(l)=xs(l)-xyzs(l,jj)
                    do while(abs(xs1(l))>0.5)
                      xs1(l)=xs1(l)-sign(1.0,xs1(l))
                    enddo
                    if(abs(xs1(l))>dxmax(l)) cycle do_pk
                  enddo
                  if(quadr(xs1,xs1,ttt)<=dm) then 
                    if(ir>0) xyzs(4,ir)=0.0
                    ir=0
                    if(ifPatt /= 1) then
                      if(b(10) <= xyzs(4,jj) ) cycle do_ix
                    else
                      if(b(10) <  xyzs(4,jj) ) cycle do_ix
                    endif
                    xyzs(1,jj)= xx
                    xyzs(2,jj)= yy
                    xyzs(3,jj)= zz
                    xyzs(4,jj)= b(10)
                    ir=jj
                  endif
               enddo do_pk
             enddo 
             if(ir>0) cycle do_ix
            endif
            NumPeaks=nop1
            if (NumPeaks .ge. limit) then
              call sortf(xyzs, 5, NumPeaks, 4)
              NumPeaks = npic
              alevel = xyzs(4,npic) + 0.5
              limit = min0(MaxAtoms, 2*nats)
            endif
          enddo do_ix ! fine loop su ix
        enddo ! fine loop su iy
      enddo ! fine loop su iz
!
!-- sort peaks in order of peak height
!
      call sortf(xyzs, 5, NumPeaks, 4)
!
      return
      end
!-----------------------------------------------------------------------
      function quadr(x1,x2,t)
!
!-- function used in the calculation of distances and angles
!
      dimension x1(3),x2(3),t(3,3)
      quadr=0.0
      sum=0.0
      do i=1,3
         q1  = t(i,1) * x1(1)
         q2  = t(i,2) * x1(2)
         q3  = t(i,3) * x1(3)
         qq  = q1 + q2 + q3
         qqp = x2(i) * qq
         sum = sum + qqp
      enddo
      quadr = sum
      return
      end
!-----------------------------------------------------------------------
      subroutine oper(j,xn,x,y,z)
      USE Symmetry
!
!-- apply j'th symmetry element to x,y,z & put result in xn
!
      common /cent/ tl(12),fs(216),mlat
      real xn(3)
!
      isym = mod(j, nsym)
      if (isym == 0) isym = nsym
      ip = (j-1) / nsym
      if(ip==0.and.mlat==0) then
        ilat=0
      else
        ilat = 3 * mod(ip, mlat)
      endif
      jt = 3 * (isym-1)
      jj = 9 * isym - 8
      do l=1, 3
         ind1 = jt + l
         ind2 = ilat + l
         xn(l) = x * fs(jj) + y * fs(jj+1) + z * fs(jj+2)
         if (ip >= mlat) xn(l) = -xn(l)
         xn(l) = xn(l) + tsvet(ind1) + tl(ind2)
         jj = jj + 3
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      function side(term0)
!
      termm = term0
      termm=termm-int(termm)
      if(termm<0.0) termm=termm+1.0
      if(termm>1.0) termm=termm-1.0
      side=termm
!
      return 
      end
!-----------------------------------------------------------------------
      integer function sidepp(nterm0,nbin)
c
      ntermm = nterm0
      do while(ntermm<0)
          ntermm=ntermm+nbin
      enddo
      do while(ntermm>=nbin)
          ntermm=ntermm-nbin
      enddo
      sidepp=ntermm
c
      return
      end
!-----------------------------------------------------------------------
      subroutine PosizioneAssoluta(xyzMin, xyzP)
      USE General
!
!-- moves xyzMin close to xyzP deleting cell translations
!
      implicit none
      integer i1, i2, i3, i
      real trasla(3), zn(3), d(3), s(3), dm, xyzMin(3), xyzP(3)
      real cdist, dist, dist2
!
      dm = 9999
      do i1=-2,2
         trasla(1) = i1
         do i2=-2,2
            trasla(2) = i2
            do i3=-2,2
               trasla(3) = i3
               zn(1:3) = xyzMin(1:3) + trasla(1:3)
               d(1:3) = zn(1:3) - xyzP(1:3)
               dist = cdist(gdist, d, dist2)
               if (dist < dm) then
                   dm = dist
                   s(1:3) =  zn(1:3)
               endif
            enddo
         enddo
      enddo
!
      xyzMin(1:3) = s(1:3)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine maxminSir(nx,ny,nz,x)
      USE General
      USE Param
!
      real x(1:nx, 1:ny, 1:nz)

      denmin =  1.0e25
      denmax = -1.0e25
      avden  =  0.0
      stden  =  0.0
!     denmax=maxval(x(1:nx,1:ny,1:nz))   ! ci mette 3 volte in piu'
!     denmin=minval(x(1:nx,1:ny,1:nz))   ! utilizzando maxval, minval, sum !!!!
!     avden =sum(x(1:nx,1:ny,1:nz))
!     stden =sum(x(1:nx,1:ny,1:nz)**2)
      do iz = 1, nz
         do iy = 1, ny
            do ix = 1, nx
               xx = x(ix, iy, iz)
               denmax = amax1(denmax, xx)
               denmin = amin1(denmin, xx)
               avden = avden + xx
               stden = stden + xx * xx
            enddo
         enddo
      enddo
!
      avden = avden / float(nx * ny * nz)
      stden = stden / float(nx * ny * nz) - avden * avden
      if (stden > 0.0) then
          stden = sqrt(stden)
      else
          stden = 0.0
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CalcGrid
      USE General
      USE Mappa
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
 
      if (igrid.eq.1) then
          sum=0.0
          res=0.5/sqrt(rhomax)
c         nx=0
c         ny=0
c         nz=0
c         call gridres(res,nx,ny,nz)
          call gridres(res)
c         np(1)=nx
c         np(2)=ny
c         np(3)=nz
          do i=1,3
             sum=sum+cell(i)/np(i)
          enddo
          factr=sum/3.0
      else
          do
             do 280 i=1,3
                np(i)=cell(i)/factr+0.5
                if (np(i).le.2*ihmx(i)) np(i)=2*ihmx(i)+1
                if(i.eq.3) np(i)=np(i)+mod(np(i),2)
  250           ntest=np(i)
                do 270 j=2,5
  260              if(ntest.ne.(ntest/j)*j) go to 270
                   ntest=ntest/j
                   if(ntest.eq.1) go to 280
                   go to 260
  270           continue
                np(i)=np(i)+1
                if(i.eq.3) np(i)=np(i)+1
                go to 250
  280        continue
             if (np(1).le.300) exit
             factr=factr+0.02
          enddo
      endif
 282  continue

      res=0.5/sqrt(rhomax)
c     if (igrid.eq.0) call gridres(res,np(1),np(2),np(3))
      if (igrid.eq.0) call gridres(res)

 283  continue

!
!--shifts per peak search
!
      ishift(1:3,1) =(/ -1,  0, -1/)
      ishift(1:3,2) =(/  0, -1, -1/)
      ishift(1:3,3) =(/  0,  0, -1/)
      ishift(1:3,4) =(/  0,  1, -1/)
      ishift(1:3,5) =(/  1,  0, -1/)
      ishift(1:3,6) =(/ -1, -1,  0/)
      ishift(1:3,7) =(/ -1,  0,  0/)
      ishift(1:3,8) =(/ -1,  1,  0/)
      ishift(1:3,9) =(/  0, -1,  0/)
      ishift(1:3,10)=(/  0,  0,  0/)
      ishift(1:3,11)=(/  0,  1,  0/)
      ishift(1:3,12)=(/  1, -1,  0/)
      ishift(1:3,13)=(/  1,  0,  0/)
      ishift(1:3,14)=(/  1,  1,  0/)
      ishift(1:3,15)=(/ -1,  0, +1/)
      ishift(1:3,16)=(/  0, -1, +1/)
      ishift(1:3,17)=(/  0,  0, +1/)
      ishift(1:3,18)=(/  0,  1, +1/)
      ishift(1:3,19)=(/  1,  0, +1/)
!
      return
      end 
!-----------------------------------------------------------------------
      subroutine gridres(res)

      USE General
      USE Symmetry
      USE Mappa, only : np

      integer nu0,nv0,nw0,nu,nv,nww
      integer mu,mv,mw,i,fftfac
      external fftfac
      real res
!
 
c calculate grid required for a particular data resolution


c     write(6,*)'RESOLUTION (for GRID)=', res

      if (ifFreeLunch > 0) then
        nu0=3*int(cell(1)/res)+1
        nv0=3*int(cell(2)/res)+1
        nw0=3*int(cell(3)/res)+1
      else
        nu0=2*int(cell(1)/res)+1
        nv0=2*int(cell(2)/res)+1
        nw0=2*int(cell(3)/res)+1
      endif

c Set up factors required by symmetry and fft
      mu=2
      mv=2
      mw=2
      do 100 i=1,nsym
       if (tsmat(1,i).ne.0.0) mu=max(mu,nint(1.0/tsmat(1,i)))
       if (tsmat(2,i).ne.0.0) mv=max(mv,nint(1.0/tsmat(2,i)))
       if (tsmat(3,i).ne.0.0) mw=max(mw,nint(1.0/tsmat(3,i)))
100   continue
      if (mod(mu,2).eq.1) mu=mu*2
      if (mod(mv,2).eq.1) mv=mv*2
      if (mod(mw,2).eq.1) mw=mw*2
c
      np(1)=fftfac(nu0,mu)
      np(2)=fftfac(nv0,mv)
      np(3)=fftfac(nw0,mw)

c print the result
c     write (lo,120)np(1:3)

 110  format(
     +/' Grid dimensions ',3i4,'  must contain the following prime'
     +/' factors for agreement with symmetry restrictions- ',3i4/)

 120  format(
     +/' Map Grid dimensions: ',3i4)
c check the input grid - should only fail if input by user

      if (mod(np(1),mu)+mod(np(2),mv)+mod(np(3),mw).ne.0) then
        write(lo,*)' GRID does not fit symmetry restrictions'
      endif

      return
      end
c
c ----------------------------------------------------------------------
c
      integer function fftfac(n0,m0)

c FFTFAC - find the composite number greater n than n0 which
c will optimise the speed of the fft and has m0 as factor
c (naive calculation: time = (p1.p2.p3...pn).(p1+p2+p3+..pn) )
c
      integer n0,m0
c
      integer nprime
      parameter (nprime=5)
      integer iprime(10),i,j,n,n1,nmin,time,timemin,sum,prod
      data iprime/2,3,5,7,11,13,17,19,23,27/
c
      n1=((n0+m0-1)/m0)*m0
      nmin=0
      timemin=1000000
c Try a number
      do 200 n=n1,2*n1,m0
c decompose n and add its factors to sum and prod
       i=n
       sum=0
       prod=1
       do 150 j=1,nprime
 100    if (mod(i,iprime(j)).eq.0) then
         i=i/iprime(j)
         sum=sum+iprime(j)
         prod=prod*iprime(j)
         goto 100
        endif
 150   continue
       time=sum*prod
       if (i.eq.1.and.time.lt.timemin) then
        nmin=n
        timemin=time
       endif
 200  continue
c
      fftfac=nmin
c
      return
      end
!-----------------------------------------------------------------------
      subroutine CCP4MAPOUT(jpatt,map,np,FileMapName)
!
!-- if jpatt = 1 space group P 1 will be used
!
      USE General
      USE Symmetry
      USE Param
!
!-- Max number of symmetry operations
!
      integer MAXSYM
      parameter (MAXSYM = 192)

      INTEGER NSPGR
      REAL rsymCCP4(4,4,MAXSYM)

      integer np(3),grid(3),uvw(6)
      real CELL_CCP4(6)
      real map(0:np(1)-1,0:np(2)-1,0:np(3)-1)

      CHARACTER TITLE*80
      character (len=*) :: FileMapName
 
 
      integer ifast,imedm,islow,lfast,lmedm,lslow,ierr,ifail
      integer m1(3),m2(3),ifms(3),jfms(3),juvw(3)
      integer i,m,iu,iv,iw,ltmp,lmap1
      integer numbSect,mode,nsymp,nsymCCP4
      character SPGRNAM*10,LTYPE*1,PGNAM*10
      integer maxsec, iprintCCP4

      real, allocatable :: lsec(:)
 
c spacegroups with yxz=1 and zxy=2 axis ordering
      integer axis(230), nSpaceGroupSav
      data axis/2,2,2,2,1,1,1,1,1,2,1,1,1,1,1,2,2,2,1,2,2,1,2,207*1/
c
c Note: juvw convert from fast/med/slow to u/v/w
c       jfms convert from u/v/w to fast/med/slow
c
c now open map header and read map, re-ordering it as necessary

      iprintCCP4 = 0
      CELL_CCP4(1:6)=cell(1:6)
      nSpaceGSav(:) = nSpaceG(:)
      nSpaceGroupSav = nSpaceGroup
      if (jpatt == 1) then
          Inte = 'p 1'
          nSpaceGroup = 1
      endif

!-- Get symmetry info from file SYMOP (syminfo.lib - Env. Var. CLIBD)
      call SpaceGroupCCP4(NSPGR,SPGRNAM,PGNAM,nsymp,
     *                   nsymCCP4,rsymCCP4,LTYPE)
      
      nSpaceG(:) = nSpaceGSav(:)
      nSpaceGroup = nSpaceGroupSav
      grid(1:3)=np(1:3)

      uvw(1) = 0
      uvw(2) = np(1)-1
      uvw(3) = 0
      uvw(4) = np(2)-1
      uvw(5) = 0
      uvw(6) = np(3)-1

c
      if (axis(mod(NSPGR,1000)).eq.1) then
       jfms(1)=2
       jfms(2)=1
       jfms(3)=3
      else
       jfms(1)=3
       jfms(2)=1
       jfms(3)=2
      endif
 
      do i=1,3
       juvw(jfms(i))=i
      enddo 

 
      m1(juvw(1))=uvw(1)
      m2(juvw(1))=uvw(2)
      m1(juvw(2))=uvw(3)
      m2(juvw(2))=uvw(4)
      m1(juvw(3))=uvw(5)
      m2(juvw(3))=uvw(6)
      numbSect=m2(3)-m1(3)+1
      mode=2
 
!gl!  write(TITLE,'(20a4)')itle
      TITLE = Titolo
 
      lmap1=3
      call mwrhdl(lmap1,FileMapName,TITLE,numbSect,jfms,grid,
     +     m1(3),m1(1),m2(1),m1(2),m2(2),CELL_CCP4,NSPGR,mode,
     *     iprintCCP4)

      call msywrt(lmap1,nsymCCP4,rsymCCP4)
 
c find out the mask grid dimensions
      lfast=m2(1)-m1(1)+1
      lmedm=m2(2)-m1(2)+1
      lslow=m2(3)-m1(3)+1
 
      maxsec = lfast * lmedm
      if (.not.allocated(lsec))
     *    allocate(lsec(0:maxsec), stat = ierr)

      lsec(0:maxsec)=0.0


c now write the map in the new order
      do islow=0,lslow-1
c sort onto section
       ifms(3)=islow+m1(3)
       do imedm=0,lmedm-1
        ifms(2)=imedm+m1(2)
        do ifast=0,lfast-1
         ifms(1)=ifast+m1(1)
         iu=ifms(juvw(1))
         iv=ifms(juvw(2))
         iw=ifms(juvw(3))
         lsec(ifast+lfast*imedm)=map(iu,iv,iw)/volume
        enddo 
       enddo 
c write the section
       call mspew(lmap1,lsec)
      enddo 
c close the map file
      call mwclose(lmap1)
 
c     write(lo,*)
c     write(lo,*)FileMapName
c     write (lo,'(a,/)') ' ****  MAP WRITE SUCCESSFUL  **** '

      if (allocated(lsec))
     *   deallocate(lsec, stat = ierr)

      return
      end
!-----------------------------------------------------------------------
****  subroutine CCP4MAPIN(np,FileMapName)
      subroutine CCP4MAPIN(FileMapName, np, nptemp, celltemp, nspace,
     *                     ifail, iprintCCP4, ier)
      USE General
      USE Symmetry
      USE MappaAutre
!
!     ifail          open failure
!                    = 0 exit from program
!                    = 1 controlled by the program
!     iprintCCP4     print code
!                    = 0 CCP4 diagnostic on failure
!                    = 1 CCP4 verbose
!                    = -1 no diagnostic at all
!
!-- Max number of symmetry operations
!
      integer MAXSYM
      parameter (MAXSYM = 192)

      INTEGER NSPGR
      REAL rsymCCP4(4,4,MAXSYM)

      integer np(3),grid(3),uvw(6)
      real CELL_CCP4(6)

      CHARACTER TITLE*80,FileMapName*200
 
 
      integer ifast,imedm,islow,lfast,lmedm,lslow,ierr,ifail,iprintCCP4
      integer m1(3),m2(3),ifms(3),jfms(3),juvw(3)
      integer i,m,iu,iv,iw,ltmp,lmap1
      integer numbSect,mode,nsymp,nsymCCP4,mspgrp
      real rmin,rmax,rmean,rrms,u,v,w,u1,v1,w1,rho
      character SPGRNAM*10,LTYPE*1,PGNAM*10
      integer maxsec
      integer nspace, nptemp(3)
      real celltemp(6)

      real, allocatable :: lsec(:)

c
c
c Note: juvw convert from fast/med/slow to u/v/w
c       jfms convert from u/v/w to fast/med/slow
c
c now open map header and read map, re-ordering it as necessary
c
c     Valori iniziali 
      ier = 0
      uvw(1) = 0
      uvw(2) = np(1)-1
      uvw(3) = 0
      uvw(4) = np(2)-1
      uvw(5) = 0
      uvw(6) = np(3)-1

!     ifail=0        passat0 come parametro
!     iprintCCP4=0   passat0 come parametro

      lmap1=2
      call mrdhds(lmap1,FileMapName,title,numbSect,jfms,grid,
     *     m1(3),m1(1),m2(1),
     +     m1(2),m2(2),cell_ccp4,mspgrp,mode,rmin,rmax,rmean,rrms,ifail,
     &     iprintCCP4)
      if (ifail < 0) then
          ier = -1
          return
      endif

!
!-- Calcolo volume
!
      a1  = cos(cell_ccp4(4) * pi / 180.0)
      a2  = cos(cell_ccp4(5) * pi / 180.0)
      a3  = cos(cell_ccp4(6) * pi / 180.0)
      arg = 1.0 - a1*a1 - a2*a2 - a3*a3 + a1*a2*a3 * 2.0
      volume = cell_ccp4(1) * cell_ccp4(2) * cell_ccp4(3) * sqrt(arg)

!

      m2(3)=m1(3)+numbSect-1

      do i=1,3
       juvw(jfms(i))=i
      end do


c check we got the right header info:

      if (uvw(1).ne.m1(juvw(1)).or.uvw(2).ne.m2(juvw(1)).or.
     +     uvw(3).ne.m1(juvw(2)).or.uvw(4).ne.m2(juvw(2)).or.
     +     uvw(5).ne.m1(juvw(3)).or.uvw(6).ne.m2(juvw(3))) then

*      write(6,*) 'CCP4MAPIN - map grid sizes are inconsistent'
      endif

      npAutre(1:3) = grid(1:3)
      call AllocaMappaAutre(2)
      call AllocaMappaAutre(1)

c find out the map grid dimensions

      lfast=m2(1)-m1(1)+1
      lmedm=m2(2)-m1(2)+1
      lslow=m2(3)-m1(3)+1
c
      maxsec = lfast * lmedm
      if (.not.allocated(lsec))
     *    allocate(lsec(0:maxsec), stat = ierr)


c now read the map in the order it is on file
      do islow=0,lslow-1
c get a section
       ierr=0
       call mgulpr(lmap1,lsec,ierr)
       if (ierr.ne.0) write(6,*) ' ccpmapin - ccp4 read error'
c now sort into uvw map
       ifms(3)=islow+m1(3)
       do imedm=0,lmedm-1
        ifms(2)=imedm+m1(2)
        do ifast=0,lfast-1
         ifms(1)=ifast+m1(1)
         iu=ifms(juvw(1))
         iv=ifms(juvw(2))
         iw=ifms(juvw(3))
         xmapAutre(iu,iv,iw)=lsec(ifast+lfast*imedm) * volume
        enddo
       enddo
      enddo
c close the map file
      call mrclos(lmap1)
!
      if (iprintCCP4 /= 0) then
          write (lo,'(/,a,/)') ' ****  MAP READ SUCCESSFUL  **** '
      endif
!
      celltemp(1:6) = cell_ccp4
      nptemp(1:3) = grid(1:3)
      nspace = mspgrp
!
      return
      end
!-----------------------------------------------------------------------
