namespace main_app {
                extern "C" int Main(int argc, char *argv[]);
               }
#ifdef G95
extern "C"
{
void g95_runtime_start(int argc, char *argv[]);
void g95_runtime_stop();
}
#endif
#include <vector>
#include <locale>
#include <cstring>
#ifdef _WIN32
#include "windows.h"
#pragma comment( lib, "glew32.lib" )
#if defined (_MSC_VER) && (_MSC_VER < 1700)

int APIENTRY WinMain(HINSTANCE ,
                     HINSTANCE ,
                     LPTSTR    ,
                     int       )
{
  LPTSTR str = ::GetCommandLine();
  char *cmd = g_strdup(str);

#else

#include <tchar.h>
#include <AtlBase.h>
int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
                     _In_opt_ HINSTANCE hPrevInstance,
                     _In_ LPTSTR    lpCmdLine,
                     _In_ int       nCmdShow)
{
  USES_CONVERSION;

  UNREFERENCED_PARAMETER(hInstance);
  UNREFERENCED_PARAMETER(hPrevInstance);
  UNREFERENCED_PARAMETER(nCmdShow);
  UNREFERENCED_PARAMETER(lpCmdLine);
  LPTSTR str = ::GetCommandLine();
  char *cmd = g_strdup(T2A(str));
#endif

  int result;
  std::vector<char *>argvv;
  bool quote=false, endcmd = true;

  for(char *p=cmd; *p!='\0'; ++p) 
  {
    if( *p=='\"' )
    {
      if( quote )
      {
        *p = '\0';
        endcmd = true;
      }
      quote = !quote;
      continue;
    }
    if(!quote && *p==' ')
    {
      *p = '\0';
      endcmd = true;
      continue;
    }
    if( endcmd )
    {
      argvv.push_back(p);
      endcmd = false;
    }
  }
  
#ifdef G95
    g95_runtime_start(argc, argv);
#endif
    SetThreadLocale(MAKELCID(MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US),SORT_DEFAULT));
//mr310511    gtk_disable_setlocale();
#ifdef MACOSX
    gtk_disable_setlocale();
#endif
    char *sl = setlocale( LC_ALL, "English" );
    if(sl == NULL)
       sl = setlocale( LC_ALL, "" );
       //sl = setlocale( LC_ALL, "C" );
    if(sl == NULL)
       printf("errore in setlocale\n");
    result = main_app::Main(static_cast<int>(argvv.size()), &*argvv.begin());
#ifdef G95
    g95_runtime_stop();
#endif
   return result;
}

#else

int main (int argc, char **argv)
{
  int result;
#ifdef G95
    g95_runtime_start(argc, argv);
#endif
//mr251111    gtk_disable_setlocale();

#ifdef MACOSX
    gtk_disable_setlocale();
#elif !defined(_WIN32)
    setenv("UBUNTU_MENUPROXY", "0", 1);
#endif
    char *sl = setlocale( LC_ALL, "English" );
    if(sl == NULL)
    {
       //sl = setlocale( LC_ALL, "C" );
       sl = setlocale( LC_ALL, "" );
       struct lconv *lc = localeconv();
       if(strstr(lc->decimal_point, ","))
          sl = setlocale( LC_ALL, "C" );
       setenv("LC_NUMERIC", "en_US.UTF-8", 1);
    }

    result = main_app::Main(argc, argv);
#ifdef G95
    g95_runtime_stop();
#endif
   return result;
}
#endif
