#include "mrconfig.h"
#include "cry.h"
Crystal *crys;
Dataset *dataset;
crystal_t *cryphC;
int *natomsC;
int *nelemC;
int numphC;

extern "C"
{
void put_info_crystal_(int *numph,int *natoms,int *nelem,
                                  crystal_t *cryph)
{
   natomsC = natoms;
   nelemC  = nelem;
   numphC  = *numph;
   cryphC = cryph;
   crys = g_new0(Crystal, numphC);
}

void put_info_ph_(element_type *elem, atom_type *at, int *i)
{
   int j = *i-1;
   crys[j].FillCrystal(natomsC[j], nelemC[j], cryphC[j], at, elem);
}
void put_info_po_(int *kopcorr, int *hklpo, int *gcode, float *gpar, int *i)
{
   int j = *i-1;
   crys[j].SetKopcorr(*kopcorr);
   for(int k=0; k<3; k++)
       crys[j].SetHKLpo(k, hklpo[k]);
   crys[j].SetGpar(*gpar);
   crys[j].SetGcod(*gcode);
}

}
