
/*-------------------------------------------------------------*/
/*                   Common del Fortran                        */
/*-------------------------------------------------------------*/
#define MaxAtLSQ 3000
#define RParDef  10
#define SizeKFix 19
#ifndef SIR_PGM
#define SIR_PGM 1
#endif

typedef struct {
               int    LSQinit        [20];
               int    IsoAnisoGTK    [MaxAtLSQ];
               int    kFixGTK        [MaxAtLSQ] [SizeKFix];
               int    nObsGTK        [10];
               float  WParDefGTK     [RParDef] [20];
               int    nParDefGTK     [20];
               float  WParGTK        [RParDef];
               int    nresGTK        ;
               float  vresGTK        [6000];
               int    natsGTK        ;
               int    nGruppiDefined ;
               char   AtomsGTK       [(MaxAtLSQ+1)*8];
               int    ifCubo         ;
               float  latoCubo       ;
               float  xyzCubo        [3];
               int    ixCubo         ;
               int    iyCubo         ;
               int    ipxCubo        [9] [3];
               } _LSQinfo;

typedef struct {
                 int ifDrawContour;
                 int nLevels[2];
                 int ifLevel[5];
                 float Soglie[15];
                 int LevelCol[5];
                 int nPuntiCont;
                 int nPuntiLev[15];
                 int Layer;
                 int sezione0;
                 int sezioneN;
                 float centerCont[3];
                 float deltaCont[3];
                 float xyzlimCont[3][2];
                 int ifModel;
                 int massimoMappa;
                 int ifGrid;
                 int WhichLimit;
                 int WhichRes;
                 int xyz_triadim;
                 int Max_Points;
                 int ifOriented;
                 int numCell[2][3];
                 int ifSkeleton;
                 int nSkel;
                 int nSkelLeg;
                 int noSkeleton;
		 int ifDrawContour2D;
               } _CContour; 

typedef struct {
                 int ifProject;
               } _Project;

typedef struct {
                 int l[100];
               } _Liste;

typedef struct {
                 float xyzfou[4][3];
                 int  ncondfou[2][3];
                 float xcondfou[5][4][2][3];
               } _Limfour;

typedef struct {
                 int   ifFirstTime;
                 int   ifScale;
                 int   kplty;
                 int   ifDrRes;
                 float AngDef;
                 float PercTra;
                 int   ifContour;
                 int   ifGhost;
                 int   ifDrHydr;
                 int   ifDrHBond;
                 float FProb;
                 int   ifHardC;
                 int   ifPersp;
                 int   ifChangedXYZ;
                 int   IfChangeHM;
                 int   IfHelpEnabled;
                 int   IfRotTran;
                 int   iPlotTypePoly;
                 int   ifBuildPoly;
                 int   ifLabelsPoly;
                 int   ifContPoly;
                 float ViewDistPoly;
                 int   natsPoly;
                 int   iActive[20];
                 int   nUltRot;
                 int   ifSymmCont;
                 int   ifViewer;
               } _PlotOpts;

typedef struct {
               int nspec_lab;
               int ispecie_lab[2];
               int npeaks_lab[2];
               int ncoord_lab[2];
               float valori_lab[4];
               int num_polyhedra1;
               int natomo_p1[100];
               int ncoord_p1[100];
               float dist_p1[100];
               float tol_dis_p1[100];
               float tol_ang_p1[100];
               int num_polyhedra2;
               int natomo1_p2[100];
               int natomo2_p2[100];
               int nspec_p2[100];
               int ncoord_p2[100];
               float dist_p2[100];
               float tol_dis_p2[100];
               float tol_ang_p2[100];
               int kmethod;

               int num_spec_draw;
               int nspecie_draw[100];
               int ncoord_pdraw[100];
               float dist_draw[100];
               float tol_dis_draw[100];
               float tol_ang_draw[100];
              } _Directinfo;

/*
typedef struct {
      float xc[3];   // x,y,z
      float biso;    // fattore termico
      float och;     // occupanza chimica
      float ocry;    // occupanza cristall.
      float inte;     // intensita' di picco
      int nz;        // nz
      char lab[16];  // label
      int rcod[5];   // posizione nella matrice jac. del parametro se affinato; 0 se non affinato
                }  atom_type;

*/
/*-------------------------------------------------------------*/

