!------------------------------------------------------------------
      subroutine PreEdmDedm(ifFromPhase, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE PhaseModule
      USE Mappa
      USE MapTest
      USE Param
      USE Skeleton
      USE CowMod
!
      integer :: jumpData, nstrData, negF
      real    :: btData, enData
      common /DataToNormal/ jumpData, btData, nstrData, enData, negF
      integer kh, kk, kl, ivet(3)
      real celltemp(13),shi1(4)
      real fig(11)
      logical ifEof
!
!     ifDEDM = 2
c       ifExamin = 1
c       call esamin(khl,mkang,ipub,iphaz,nrefl,1,wtt1,wt,errm1,errmw1,
c    *             nref1,shi1)

      th  = 99999999
      valoriMTZ(:) = 0.0
      if (knw == 1) ifExamin = 1
!
      call RoutineHeader('EDM / DEDM')
!
      if (ifFromPhase == 0) then
          call scrper(' Reading data ',0,-1)
      else
          numBox = 4
          Inte = '<big><b>Final EDM refinement:</b></big>'
          call TestoGR(Inte, color_RED, 2, numBox)
      endif
!
      call diredm(ifFromPhase, ier)
!
      if (ifMTZ == 1) then
          iAction = 2
          lix1 = 0
          lix2 = 0
          call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
!
!-- legge i riflessi
!
          nreflDim = nreflMTZ
          call AllocaRiflessi(1)
          i = 0
          ihmx(1:3) = -100
          do 
             call GetHklMTZ(jump, kh, kk, kl, ifEof)
             if (ifEof) exit
             if (jump == 1) cycle
             i = i + 1
             ivet(1) = kh
             ivet(2) = kk
             ivet(3) = kl
             khl(1:3,i) = ivet(1:3)
             j = 4
             k = 1
             if (knw == 1) then
                 ipub(i) = nint(valoriMTZ(k))
                 k = 2
             else
                 ipub(i) = 0
             endif
             fovet(i)  = valoriMTZ(k)
             sigmav(i) = valoriMTZ(k+1)
             iphaz(i)  = nint(valoriMTZ(k+2))
             wt(i)     = valoriMTZ(k+3)
             fcvet(i)  = valoriMTZ(k+4)
             call geneq(1,kh,kk,kl,idelt,jcode,isgnn,id1,rho,ireje)
             mkang(i) = jcode
             rhov(i) = rho
             if (ihmx(1).lt.iabs(ivet(1))) ihmx(1)=iabs(ivet(1))
             if (ihmx(2).lt.iabs(ivet(2))) ihmx(2)=iabs(ivet(2))
             if (ihmx(3).lt.iabs(ivet(3))) ihmx(3)=iabs(ivet(3))

             call cmult2002(ivet,eps,multi)
             epsv(i) = eps
             mult(i) = multi
          enddo
          nrefl = i
          write(lo,110) nrefl,MTZfile(1:Lung(MTZfile))
!
          iAction = 3
          lix1 = 0
          lix2 = 0
          call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
!
!-- scrive i riflessi su disco
          call MTZ2RiflessiNew()
          call AllocaRiflessi(2)
          nreflDim = nrefltot
          call AllocaRiflessi(1)
!
!-- normalize reflections
!
          listRefl = 10
          jumpData = -1
          btData = 0.0
          nstrData = 0
          ifMercedes = 0
          call norm2000(ifMercedes, ier)
          if (knw == 1) then
              call AllocaTestStuff(1)
          endif
      else
          ! dritan: per il momento le fasi/peso li prendo dalla memoria
c         go to 50
          !
          if (.not.allocated(iphaz)) then
              call AllocaRiflessi(1)
          endif
          no17 = 0
          if (sum(iphaz(:)) == 0) then
              lfw = InfoOK(17)
              if (lfw.gt.0) then
                  if (ifWasRemo == 0) then
                      ksubr = 3
                  else
                      ksubr = 4
                  endif
                  call LeggiRiflessi(ier, ksubr)
!gl!              call sfl17()
                  call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                                 nsetFinalPhases)
                  if (nSetsFineDSR <= 0 .or. ier < 0) then
                      no17 = 1
                  else
                      do i=1, nSetsFineDSR
                         nset = iposFineDSR(i)
!gl!                     call snr17(nset,fig)
                         call PutGetFinalPhases(2, nset, fig)
                         OldTRialsForDLSQ(i,1:11) = fig(1:11)
                      enddo
                  endif
              else
                  no17 = 1
              endif
          endif
          if (no17 == 1) then
              write(Msg,11)
              call MsgWinErr('Error',Msg,ERR_WINDOW,iex)
              ier = -1
              return
          endif
      endif

 50   continue
!
c     do i=1, nrefl
c        write(6,100) i,khl(1:3,i),ipub(i),fovet(i),sigmav(i),
c    *                fcvet(i),iphaz(i),wt(i)
c        write(1,'(3i4,6f10.2)') khl(1:3,i),float(ipub(i)),
c    *                fovet(i),sigmav(i),
c    *                evet(i),float(iphaz(i)),wt(i)
c     enddo
       wtt1(:) = 1.0
       if (knw > 0) then
        ifExamin = 1
        call esamin(khl,mkang,ipub,iphaz,nrefl,1,wtt1,wt,errm1,errmw1,
     *             nref1,shi1)
       endif

       iy=67543
       ix=iy

       do i=1,nrefl
c       fovet(i) = sqrt(sc)*fovet(i)
c       sigmav(i) = sqrt(sc)*sigmav(i)
c       sigmav2(i) = sc*sigmav2(i)
        if (wt(i) < 0.0 ) then
          iphaz(i) = 0
          wt(i) = 0.0
        endif
        ! per il calcolo di Rfree
        call randu1(ix,iy,yfl)
        flag=real(int(yfl*20.0)+1)
        ix=iy
        rfree1(i)=flag
        free1(i)=0.0
        free2(i)=0.0
        !
        if (knw > 0) then
          nh1=khl(1,i)
          nk1=khl(2,i)
          nl1=khl(3,i)
          iphaz(i)=shi1(4)*iphaz(i)-360.*(nh1*shi1(1)+nk1*shi1(2)+
     *             nl1*shi1(3))
          iphaz(i)=mod(iphaz(i)+3600,360)
          if (iphaz(i).le.0) iphaz(i)=360+iphaz(i)
        endif
       enddo

c      f000=0.0
c      v_m=0.0
c--------------------------------------
c      den=0.0
c      do i=1,nk
c        f000=f000+float(nw(i)*no(i))
c        den=den+float(nw(i)*nw(i)*no(i))
c        if (no(i).gt.1) then
c           v_m=v_m+14.0*float(nw(i))
c        endif
c      enddo
c---- Matthews' number
c     v_m=volume/v_m
c---- Percent of Protein
c-----  protein density=1.23 (from CCP4 1.34)
c     v_p=1.23/v_m
c     v_p=1.34/v_m
      f000=volume*(0.32*(1.0-v_p)+0.43*v_p)
      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)

      rhomax = maxval(rhov(1:nrefl))
      res=0.5/sqrt(rhomax)
      if (knw == 1) then
          write(lo,*)'F000=', f000/volume
          write(lo,*)'v_p=', v_p
          write(lo,*)'Res=',res
          write(lo,*)'ifatx=',ifatx
      endif
c     call LoadReflInfo
c     ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
c     ifat2=(2*ihmx(3)+1)
c     ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)
c     write(lo,*)'ifatx=',ifatx
      call AllocaISR(1)
      call gridres(res)
      call calcscale

      call AllocaMappa(1)
      if (knw > 0)  call AllocaMapTest(1)

      FORTH=0
      FORTHenv=0
      BACK=0
      BACKenv=0
      WhichFFTMethod=1
c     ihism = 1

      call readhist
      call calcmetric
c     nmaMa4 = 1
c     ncycl4(1) = 20
c     ! envelope
c     iflat = 2
c     ! Rfree
c     ifree = 0
c     ifree = 1
c     ! Real-Rfree
c     ifreem = 1
c     ! convergenza
c     ifconv = 1
      !
      iphad(:) = iphaz(:)
      wtd(:) = wt(:)
c     jgamma = 1
c     icomb = 1
c     jsigmaa = 1
      ! for Rfree real
c     frpr=4.0
c     frsr=4.0
c     frpx=-1.0e6
c     frsx=-1.0e6
c     realfree=1.0e6
      ! x l'output
      Rot = 0.0
      rfree = 0.0
      errm12 = 0.0
      corr = 0.0
      corrM = 0.0
      corrE = 0.0
      realfreeR = 0.0
      !

      ncol = 2
      smax=rhomax*4.0
!gl   ndim1 = numestref(smax)
      ndim1 = numestref()
      ndim1=ndim1*2
      !write(6,*)ndim1
      ndim2=np(1)*np(2)*(np(3)+2)


      if (knw > 0) then
        fcoef(:)=fovet(:)*wt(:)
        call MakeMap(fcoef,iphaz,nrefl,0,xmap,FORTH,BACK)
        fcoef(:)=fovet(:)
        FORTH=0
        call MakeMap(fcoef,ipub,nrefl,0,xmapT,FORTH,BACK)
        call mapcorr(xmap,xmapT,corr)
        write(6,*) 'CC =', corr
        xmodel = xmap
        kk = 0
        write(lo,'(1x,"MA",1x,"MI",1x,"FOMs",2x,"NPHASED",4x,"CC",7x,
     *        "CCM",6x,"CCE",5x,"ERR",6x,"WERR",6x,"Rt",5x,"Rfree",4x,
     *        "RRFREE",4x,"DPHI")')
        write(lo,'(2i3,1x,4hFOMs,1x,i6,12(1x,f8.3))')
     *      kk,kk,nref1,corr,corrM,corrE,errm1,errmw1,
     *      Rtot,rfree,realfreeR,errm12
      endif

      call DistruggiPianiAll

c     iBonesIn = 0
c     iskelet = 1
c     sogMapSK = 1.5
c     sogLevSK = 0.5
c     lungSK = 5
c     nSparePoints = 0

      nfree=0
      if (abs(ifDEDM) > 0) then
c       ifFromGraphic = 1
c       call InitFour(ifFromGraphic,ier) ! solo se uso la ModelBuildingMio
        call TestFq(abs(ifDEDM))
      else
!cristina
       call EDMdritan(nfree, numBox, 0)

      endif

!
      return
   11 format('No phases stored, sorry.')
  100 format(i5,')',4i4,3f8.2,i4,f8.2)
  110 format(/,i6,' reflections from MTZ file ',a,/)
      end
!------------------------------------------------------------------
      subroutine diredm(ifFromPhase, ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Groups
      USE MadModule
      USE PhaseModule
      USE TestStuff
      USE Param
      USE DataModule
      USE Direttive
!
!-- read directives for this modul
!
      common /misurato/ misu  !pgMAD
      common /zeffe/ ifZeffDone, zeffOrig(18)
      integer CheckRef
      common /LaueComm/ CheckRef

      common /sfact/ nSfCard, sfacm(18,9), kSfac(18)
      integer :: jumpData, nstrData, negF
      real    :: btData, enData
      common /DataToNormal/ jumpData, btData, nstrData, enData, negF
      common/super4/ncycl4(100),percc4(100),nmaMa4 ! dritan
      dimension kshif(3)
      dimension celltemp(13)
      dimension norm0(5)      !pgMAD
      integer nHeavyV(5)
      character fileh*256, cardIsot*80
      character HetGroupLine*256
!
!-- set default values
!
      wave    = 0.71073
      ifIsot = 0
      ifHetGr = 0
      nHetGr = 0
      ifContSuppl = 0
      ifZeffDone = 0
      Moltiplica(:) = 0
      ifMTZ = 0
      ifMTZlab = 0
      nMTZlab = 0
      ZValue  = -1
      WeightSuppl = 0.0
      ifWeight = 0
      ifSeq   = 0
      ifHetam = 0
      neutro  = 0
      iprin   = 0
      Lab_Ch(:) = ' '

      ! dritan : DEDM/EDM
      ifDEDM = 0
      nivoltaD = 0
      idritanD = 0
      ifree  = 0   ! 0/1 --> non/calcolare rfree (nel caso ifEDM =1, ifree= 0 xche si usa ifreem, invece ifEDM =-1, ifree=1)
      ifreem = 1   ! 0/1 --> non/calcolare rfree mask
      ihism  = 1   ! 0/1 --> non/usare HM
      ifEDM  = 1   ! -1/0/1 --> -1 procedura FLEX, 0 nessun EDM, 1 procedura nuova
      ifExtra =0   ! 0/1 --> non/usare i riflessi extrapolated ! -1 nel caso che abbiamo gia e' riflessi da ! FreeLunch (x usare div. nel sigmaA)
      ifconv = 1   ! convergenza
      iflat = 2    ! 0 --> sol=0.0; 1--> sol=den*0.5; 2--> solvent=0.32 (default)
      jgamma = 1   ! per il gamma perturbation
      jsigmaa = 1  ! sigmaA
      icomb = 1    ! combinazione per sigmaA
      ! for Rfree real
      frpr=4.0
      frsr=4.0
      frpx=-1.0e6
      frsx=-1.0e6
      realfree=1.0e6

      ! nr. macro/micro cicli per EDM 
      nmaMa4 = 1
      ncycl4(1) = 20

      ! skeleton-Greer
      iBonesIn = 0  ! file bones from mapman
      iskelet = 1
      sogMapSK = 1.5
      sogLevSK = 0.5
      lungSK = 5
      nSparePoints = 0


c
      lixx = InfoOK(1)
      if (lixx > 0) then
          lix1  = 1
      else
          lix1 = 0
      endif
      lixx = InfoOK(2)
      if (lixx > 0) then
          lix2  = 1
      else
          lix2 = 0
      endif
      lixx = InfoOK(3)
      if (lixx > 0) then
          lix3  = 1
      else
          lix3 = 0
      endif
!
      ic    = 0
      icmax = icomq(icomat,2)
c
      do while (ic.lt.icmax.and.ier.eq.0)
         ic = ic + 1
         ipdir=ipdir+1
         cardDiret=card(ipdir)
         cardImage=cardDiret
         ldiret = Lung(cardImage)
         call cutst(cardDiret,lenp,direttiva,lend)
         call lcase(direttiva)
!
      if (direttiva(1:3).eq.'mtz') then
!
!-- check for blanks in the reflection file name
!
          call CheckBlanks(fileh, lend)
!
          if (lend > 0) then
              ReflFileName = fileh(1:lend)
              jjfile=jfile
              fileh   = ReflFileName
              MTZfile = ReflFileName
              ifMTZ   = 1
!pgMAD131006
              ind = index(ReflFileName,char(47),.TRUE.)
              ind1 = index(ReflFileName,char(92),.TRUE.)
              ind = max(ind,ind1)
              if ( (ind + ind1) > 0 ) then
                  ReflFilePath = ReflFileName(1:ind)
              endif
!pgMAD131006

!pg15-09
          else
              ier = -10
          endif
      elseif (direttiva(1:3).eq.'lab') then
          Lab_Ch(:) = ' '
          k = 0
          lenp = 1
          do while (lenp > 0)
             call cutst(cardDiret,lenp,direttiva,lend)
             k = k + 1
!            call ucase(direttiva)
             Lab_Ch(k) = direttiva
          enddo
          if (k < 5) then
              ier = -10
          else
              ifMTZlab = 1
              nMTZlab  = k
          endif
      elseif (direttiva(1:3).eq.'seq') then
!
!-- check for blanks in the reflection file name
!
          call CheckBlanks(fileh, lend)
!
          if (lend > 0) then
              SeqFile = ' '
              SeqFile = fileh(1:lend)
              jjfile=jfile
              ifSeq  = 1
          else
              ier = -10
          endif
!
!-- check for blanks in the reflection file name
!
      elseif (direttiva(1:4).eq.'heta') then
          call lcase(cardDiret)
          ifMolt = 1
          call getcon(cardDiret, direttiva, Moltiplica, ifMolt, nkk)
          nk = nkk
          if (nk.gt.0) then
             lix3=1
          ifHetam = 1
          else
             ier = -10
          endif
      elseif (direttiva(1:4).eq.'hetg') then
          ifHetGr = 1
          call ucase(cardDiret)
          HetGroupLine = cardDiret
      elseif (direttiva(1:4).eq.'neut') then
          neutro=1
      elseif (direttiva(1:4).eq.'elec') then
          neutro=2
          en = 1.0
      else
c-- directives with numeric parameters
          iopt=0
          call getnum(cardDiret,vet,ivet,iv,iopt)
          if (iopt.ne.-1) then
              if (direttiva(1:4).eq.'weig') then
                  if (iv.eq.1) then
                      WeightSuppl = vet(1)
                      ifWeight = 1
                  else
                      ier = -10
                  endif
              elseif (direttiva(1:4).eq.'nres') then
                  if (iv.eq.1) then
                      WeightSuppl = vet(1)
                      ifWeight = 2
                  else
                      ier = -10
                  endif
              elseif (direttiva(1:4).eq.'nmol') then
                  if (iv.eq.1) then
                      ZValue = vet(1)
                  else
                      ier = -10
                  endif
              elseif (direttiva(1:2).eq.'dm') then
                  select case (iv)
                   case (0)
                    ifEDM=0
                   case (1)
                     ifEDM=ivet(1)
                   case (2)
                     ifEDM=ivet(1)
                     ihism=ivet(2)
                   case (3)
                     ifEDM=ivet(1)
                     ihism=ivet(2)
                     ifExtra=ivet(3)
                   case (4)
                     ifEDM=ivet(1)
                     ihism=ivet(2)
                     ifExtra=ivet(3)
                    ! per il momento ivet(4) = 0  (si puo usare per skeleton)
                   end select
              elseif (direttiva(1:4).eq.'part') then
                    if (iv > 0) then
                     ifDEDM=ivet(1)
                     if (iv > 1) then
                        nivoltaD = ivet(2)
                        if (iv > 2) idritanD = ivet(3)
                     endif
                    else
                     ifDEDM=1
                    endif
              elseif (direttiva(1:4).eq.'skel') then
                    iskelet=1
                    if (iv == 4) then
                      sogMapSK=vet(1)
                      sogLevSK = vet(2)
                      nSparePoints = ivet(3)
                      lungSK = ivet(4)
                    else
                      ier = -10
                    endif
              endif
          else
              ier = -20
          endif
      endif
      enddo
!
      if (ier == -10) then
          write(Msg,6100) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
      if (ier == -20) then
          write(Msg,6200) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
 6100 format(' Error in directive : ',a)
 6200 format(' Wrong directive in DATA modulus:   ',a)
 6300 format(' ',a4, 'has not been declared in derivative directive')
!
!-- No Hist. Match. when atomic resolution
!
      if (ifFromPhase == 1 .and. LowRes == 0) then
          ihism = 0
      endif
!
!-- MTZ
!
      if (ifMTZ == 1) then
          iAction = 1
          call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
          if (ier < 0) return
      endif
!
      if (lix1.le.0) then
          write(Msg,8225)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier=-1
      else
          if (ifFromPhase == 0) then
              call WriteCellInfo
          endif
          call Orto(cell)
      endif
 8225 format(' No cell parameters supplied')
      if (lix2.le.0) then
          write(Msg,8245)
          call OpenWarning(Msg)
          ifLaue = 0
      else
          if (ifFromPhase == 0) then
              call WriteSymmInfo(lo)
          endif
      endif
 8245 format(' No space group symbol supplied')
!
      if (ZValue < 0) then
          ZValue = 1
      endif
!
!-- Sequence used
!
      jSav = QualePgm
      QualePgm = SIRPROTPGM
      if (ifSeq == 1) then
            call Cancella(3)
            nk = 0
            call GetSequence(lix3, Moltiplica, ier)
            if (ier < 0) return
      endif
!
!-- Weight or nResid used
!
      if (ifWeight > 0) then
          call ManageWeight(WeightSuppl, ifWeight, Moltiplica)
          lix3 = 1
      endif
!
!-- if HetAtm or Anom used the cell content has to be computed
!
      do i=1, nk
         if (Moltiplica(i) == 1) then
             nw(i) = nw(i) * totop * ZValue
         endif
      enddo
!
!-- Add the content related to Het Groups
!
      if (ifHetGr == 1) then
          cardDiret = HetGroupLine
          call GetHetGroups(nHetGr, ier)
          if (ier >= 0) then
              call ScanHetGroups(nHetGr, 1, ier)
          endif
      endif
!
      QualePgm = jSav
!
      if (ier < 0) then
          L = Lung(HetGroupLine)
          Msg = 'Check Het Groups definition: ' // HetGroupLine(1:L)
                call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif
!
      if (ier < 0) then
          return
      endif
c ---
c --- read scattering factors
c ---
      if (lix3.le.0) then
          write(Msg,8255)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier=-1
      else
          call CreaAtmPropInfo(WhichProps, ier)
          call GetFromAtmStruct
          if (ifFromPhase == 0) then
              call WriteContInfo(npq,ier)
          endif
!gl!      call yfrm03(wave,ier)
!gl!      if (ier.ge.0) then
!gl!          call yfl03
!gl!          if (ifFromPhase == 0) then
!gl!              call WriteContInfo(npq,ier)
!gl!          endif
!gl!      endif
      endif
 8255 format(' No cell content supplied')
      if (ier.lt.0) then
          return
      endif
c
c-- check on scattering factor coefficients
c
      do i=1,nk
         isum = nint(cl(i)*100.0)
         do j=1,4
            isum = isum + nint(al(j,i)*100.0) + nint(bs(j,i)*100.0)
         enddo
         if (isum.eq.0) then
             j = Lung(nomeat(i))
             write(Msg,8275) nomeat(i)(1:j)
             call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
             ier=-1
             return
         endif
      enddo
 8275 format(' Scattering factors for ',a,' not available.',
     *       ' Use SFAC directive.')
c
c-- checks on atomic species in SFAC and ANOMAULS directives
c
      if (ier.lt.0) return
      if (ifIsot == 1) then
          call GetIsotope(cardIsot, ier)
          if (ier < 0) return
      endif
!
      if (ifMTZ == 1 .and. knw > 0) then
          call WriteMTZCont()
      endif
!
      return
      end
!---------------------------------------------------------------------
      subroutine MTZ2RiflessiNew()
      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiNew
      USE RiflessiInfo
!
      implicit none
      integer :: mn, i 
      real    :: fo, fo2, sigma, sigma2
!
      mn   = int( 4.5 * anat + 100.5 )
      if (nsym == 1) mn = mn + 50
      nstr = min0( mn, maxstr )
      nstr = mn + min0( maxstr - mn, 100 ) / 2
!
!-- create preamble
!
      pack3 = 1024
      pack2 = pack3 * pack3
      pack1 = pack3 * pack2
      pack5 = pack3 / 2

!
      refl_info%nrefltot    = nrefl
      refl_info%nonoss      = 0
      refl_info%nescl       = 0
      refl_info%cutoff      = 3.0
      refl_info%iLent       = 0
      refl_info%iVelox      = 0
      refl_info%bt          = 3.0
      refl_info%sc          = -99.0
      refl_info%nvsfc       = 0
      refl_info%icdd        = 0
      refl_info%npseud      = 0
      refl_info%fosog       = 0.0
      refl_info%shiftesd(:) = 0.0
      refl_info%rhodiff(:)  = 0
      refl_info%deltahkl(:) = 0
      refl_info%rflsq       = 0
      refl_info%rwflsq      = 0
      refl_info%slsq        = 0
!
      call UpdateReflInfo
!
!-- trasferisce i  riflessi nella struttura in memoria
!
      do i=1,nrefl
         fo     = fovet(i)
         sigma  = sigmav(i)
         fo2    = fo * fo
         sigma2 = 2.0 * fo * sigma
         refl%hkl(1:3,i)  = khl(1:3,i)   ! h,k,l
         refl%e(i)        = nrefl-i+1     ! e (n. rifl.)
         refl%fo(i)       = fo            ! fo
         refl%ep(i)       = 0.0           ! e'
         refl%phasep(i)   = 0             ! phi'
         refl%pub(i)      = ipub(i)       ! phi(pub)
         refl%code(i)     = mkang(i)      ! code
         refl%sigma(i)    = sigma         ! sigma(fo+)
         refl%fc(i)       = fcvet(i)      ! fc
         refl%phase(i)    = iphaz(i)      ! phi(calc)
         refl%rho(i)      = rhov(i)       ! rho
         refl%weight(i)   = wt(i)         ! weight
         if (kmad /= 0) then
             refl%fo_meno(i)    = 0.0           ! fo(-)
             refl%fo_piu(i)     = 0.0           ! fo(+)
             refl%sigma_meno(i) = 0.0           ! sigma(fo-)
             refl%phase_meno(i) = 0.0           ! phi(-)(calc)
             refl%fc_meno(i)    = 0.0           ! fc(-)
         endif
         refl%fosq(i)     = fo2           ! fo**2
         refl%sigmasq(i)  = sigma2        ! sigma(fo**2)
         refl%observed(i) = 0             ! code(obs/omit)
      enddo
!
      return
      end
!------------------------------------------------------------------------------
      subroutine Contour2D(ier)
      USE General
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Molcom
!
      implicit none
      integer :: ier, ind, ix, iy, iSCelta, jpatt, zero
      character (len=1) :: str
!
      call RoutineHeader('2D Contour')
!
      ier = 0
      call dir2D(jpatt, zero, ier)
      if (FichierIn(1:1) == ' ') then
          call LoadPhases(ier)
          call examin(1,mkang,khl,ipub,iphaz,nrefl,0,wt,1)
      endif
      ind = 3
      ix = 0
      iy = 0
      str = ' '
      call NVisualizzatore(ind,ix,iy,str)
!
*     ifDrawContour = 1
      call AllocaContorno(1)
!
      MaxAtomsInGr = 10
      MaxAtoms = 100
      call AllocaAtomi(-9)
      NatMol = 0
      call AggiuSpig
      call InitMolplo
      ifDrawContour = 1
      ifDrawContour2D = 1
      ifSkeleton = 0
      nats = 1
      ifAlreadyProduced = 1
*     iScelta = 3
*     call ChePiano (iScelta)
      if (FichierIn(1:1) == ' ') then
          call CreaMappa(jpatt, zero)
      else
          call LeggiMappa(ier)
      endif
!
      BTot(:,:) = 0; BTot(1,1) = 1; BTot(2,2) = 1; BTot(3,3) = 1
!
      call FineMappa
!
      call PreparaContour
!old  call LeggiSezioni()
!old  call SetScaleMap()
!old  call apri_toolbar ('contour')  ! deve essere aggiornata
!old  call PlotContour()
!old  call Sistemino
!
      return
      end
!------------------------------------------------------------------------------
      subroutine dir2D(jpatt, zero, ier)
      USE General
      USE Direttive
!
      implicit none
      integer :: ier, ic, icmax, ldiret, Lung, lenp, lend, ind, ind1
      integer :: iopt, iv, nExitCode, k, kk, jpatt, zero
      character (len=256) :: fileh
!
      FichierIn = ' '
      FichierOut = ' '
      PDBfile = ' '
      MTZfile = ' '
      ifAmb = 0
      ifDNA = 1
      jpatt = 0
      zero = 0
!
      ic = 0
      icmax = icomq(icomat,2)
c
      do while (ic.lt.icmax.and.ier.eq.0)
         ic = ic + 1
         ipdir=ipdir+1
         cardDiret=card(ipdir)
         cardImage=cardDiret
         ldiret = Lung(cardImage)
         call cutst(cardDiret,lenp,direttiva,lend)
         call lcase(direttiva)
         if (direttiva(1:3).eq.'pat') then
             jpatt = 1
         elseif (direttiva(1:3).eq.'zer') then
             zero = 1
         elseif (direttiva(1:3).eq.'lab') then
             Lab_Ch(:) = ' '
             k = 0
             lenp = 1
             do while (lenp > 0)
                call cutst(cardDiret,lenp,direttiva,lend)
                k = k + 1
                Lab_Ch(k) = direttiva
             enddo
             if (k < 5) then
                 ier = -10
             else
                 ifMTZlab = 1
                 nMTZlab  = k
             endif
         elseif (direttiva(1:4).eq.'mtz ') then
!
!-- check for blanks in the reflection file name
!
             call CheckBlanks(fileh, lend)
!
             if (lend > 0) then
                 ReflFileName = fileh(1:lend)
                 fileh   = ReflFileName
                 MTZfile = ReflFileName
                 ifMTZ   = 1
                 ind = index(ReflFileName,char(47),.TRUE.)
                 ind1 = index(ReflFileName,char(92),.TRUE.)
                 ind = max(ind,ind1)
                 if ( (ind + ind1) > 0 ) then
                     ReflFilePath = ReflFileName(1:ind)
                 endif
             else
                 ier = -10
             endif
         elseif (direttiva(1:4).eq.'map ') then
!
!-- check for blanks in the reflection file name
!
             call CheckBlanks(fileh, lend)
!
             if (lend > 0) then
                 FichierIn = fileh(1:lend)
             else
                 ier = -10
             endif
         else
             ier = -20
         endif
      enddo
!
      write(6,'(a,2x,a)') 'Mtz file ',MTZfile(1:Lung(MTZfile))
      if (ier == -10) then
          write(Msg,6100) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
      if (ier == -20) then
          write(Msg,6200) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
!
      return
 6100 format(' Error in directive : ',a)
 6200 format(' Wrong directive in Contour2D modulus:   ',a)
      end
!-----------------------------------------------------------------------
      subroutine CreaMappa(jpatt, zero)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE MappaCont
      USE Param
      USE MolCom
      USE Iso_Surfaces
!
      implicit none
      integer :: ksubr, ier, jpatt, zero
      real    :: sigma3, tmatSav(192,3)
!
      if (jpatt == 1) then
          tmatSav(:,:) = tmat(:,:)
          tmat(:,:) = 0
      endif
      factr = 0
      Complet = 0
      call CheckGrid()
      call AllocaMappa(1)
      if (jpatt == 0) then
          fcoef(1:nrefl) = fovet(1:nrefl) * wt(1:nrefl)
      else
          fcoef(1:nrefl) = fovet(1:nrefl) * fovet(1:nrefl) * wt(1:nrefl)
      endif
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH, BACK)
!
      if (jpatt == 1) then
          tmat(:,:) = tmatSav(:,:)
          if (zero == 1) then
              xmapApp(:,:,:) = xmap(:,:,:)
              call DropZeroPeak()
              xmap(:,:,:) = xmapApp(:,:,:)
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiMappa(ier)
      USE General
      USE Symmetry
      USE Mappa
      USE MappaAutre
!
      implicit none
      real               :: cellOut(6), celltemp(13)
      integer            :: nspace, npOut(3), k, ishif, kshif(3)
      integer            :: iAction, ipo, ier, ierr, Lung
      integer            :: ifail, iprintCCP4
      character (len=16) :: SpaceSav
!
      celltemp(:) = 0.0
      if (iprin > 0) then
          write(lo,200) FichierIn(1:Lung(FichierIn))
      endif
      np(:) = 1
      ifail = 1
      iprintCCP4 = 0
      call CCP4MAPIN(FichierIn, np, npOut, cellOut, nspace, 
     *               ifail, iprintCCP4, ier)
      if (ier < 0) then
          ier = -1
          return
      endif
      np(1:3) = npOut(1:3)
      cell(1:6) = cellOut(1:6)
      celltemp(1:6) = cellOut(1:6)
!      
      if (iprin > 0) then
          write(0,*) 'NP',np
          write(0,*) 'CELL',cell(1:6)
          write(0,*) 'SpGr',nspace
      endif
!
      write(cardDiret,'(i5)') nspace
      call shift(cardDiret,k)
      read(cardDiret,'(16a1)') nSpaceG
      call CreaSymmetryInfo(ier)
      if (ier < 0) then
          ier = -1
          write(0,*) 'ERRORE'
          return
      endif
!
      iAction = 1
      call AllocaMappa(iAction)
      xmap(:,:,:) = xmapAutre(:,:,:)
      call AllocaMappaAutre(2)
      if (iprin > 0) then
          write(0,*) 'NSYM', nsym
          write(0,*) 'VOLUME',volume
      endif
!
!-- Calcolo matrice ortonormalizzazione
!
      call CreaCellInfo(celltemp) ! (1:6))
!
      if (iprin > 0) then
          write(lo,600) Inte(1:Lung(Inte))
      endif
!
      return
  200 format(/,' Load map file (CCP4 format) ',a,/)
  600 format(' Loading map         ', a,/)
      end
!-----------------------------------------------------------------------
