
    subroutine write_message_found(pos)
    USE strutil
    USE TestModel
    USE messagemod
    implicit none
    integer, intent(in) :: pos
    call write_message('found: '//trim(i_to_s(int(vett_test(3))))//'/'//trim(i_to_s(int(vett_test(1))))//   &
    ' dist: '//trim(r_to_s(vett_test(4),3)),pos=pos)
    end subroutine write_message_found

!------------------------------------------------------------------------------------------------------------

    subroutine write_message_found1(pos,natfound,natpub,rmsd)
    USE strutil
    USE messagemod
    implicit none
    integer, intent(in) :: pos
    integer, intent(in) :: natfound,natpub
    real, intent(in)    :: rmsd
    call write_message('found: '//trim(i_to_s(natfound))//'/'//trim(i_to_s(natpub))//   &
    ' RMSD: '//trim(r_to_s(rmsd,3)),pos=pos)
    end subroutine write_message_found1

MODULE enable_amb

implicit none

CONTAINS 

    recursive subroutine abilita_tasti(scode,state)
    USE molcom
    character(len=*), intent(in)  :: scode
    integer, intent(in), optional :: state   ! 0=set no sensitive, 1=sensitive, 2=hide
    integer                       :: statet
!
    end subroutine abilita_tasti

!---------------------------------------------------------------------------------

    subroutine abilita_tasti2(nat,nrefl,np)
    integer, intent(in) :: nat   ! num. of atoms
    integer, intent(in) :: nrefl ! num. of reflections
    integer, intent(in) :: np    ! num. of counts
!
    end subroutine abilita_tasti2

!---------------------------------------------------------------------------------

    subroutine tb_set_state(string,state)
    character(len=*), intent(in) :: string
    integer, intent(in)          :: state
!
    end subroutine tb_set_state

END MODULE enable_amb
