! ----------------------------------------------------------------------
      subroutine graphs(iz,ind,str,icolor1,icolor2)
      USE Molcom
!
      common /string/ x11string
!
      integer iz, ind, icolor1, icolor2
      integer gtkintf, lstr, Lung, ier
      character x11string*257
      character str*(*)
!
      if (kscreen == 0) return
!
      x11string = ' '                !! mr
!      
      lstr = Lung(str)
      if (lstr > 0) then
          x11string(1:lstr) = str(1:lstr)
      else
          lstr = 0
      endif
      x11string(lstr+1:lstr+1) = char(0)
!
      ier = gtkintf(ixv,iyv,iz,ind,icolor1,icolor2,x11string)
      if (ier < 0) then
          iz = -1
      endif
      if (ind >= 2000) then
          str = x11string
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine GetMessagesCode
      USE General
!
      call get_mess_codes()
!
      return
      end
! ----------------------------------------------------------------------
      subroutine zflush
      USE Molcom
!
      if (jscreen /= 0) then
          call cflush()
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine SirSetEnv(Variable)
!
      character*(*) Variable
!
      k = Lung(Variable) + 1
      Variable(k:k) = char(0)
      call mr_setenv(Variable)
!
      return
      end
!----------------------------------------------------------------------
      subroutine OpenWarning(MsgW)
      USE General
      USE Molcom
!
      character*(*) MsgW
!
      if (kscreen.eq.0) return
!
      Inte = 'Warning'
      itempo = 6000
      call MsgWin (Inte, MsgW, WARN_WINDOW, itempo)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine MsgWin(InteW,MsgW,nType,iEnterExitC)
      USE General
      USE Molcom
!
      character*(*) InteW, MsgW
!
      if (kscreen.eq.0) return    !! si puo' fare??  RS 10.08.08
!      
      l1 = Lung(InteW)
      l2 = Lung(MsgW)
      call MsgWinC(InteW(1:l1)//char(0), MsgW(1:l2)//char(0),
     *                nType, iEnterExitC)

!
      return
      end
! ----------------------------------------------------------------------
      subroutine MsgWinErr(String,mesg,nType,iExitC)
      USE General
      USE Molcom
!
      character*(*) String, mesg
      character *80 , Messaggio
      integer formatta_msgbis
!
      if (lo == 6) then
          icode = 1
      else
          icode = 0
      endif
      nchar = 70
      l2 = min0(Lung(mesg), 600)
      if (l2.gt.0) then
          Msg = mesg(1:l2)                !mr 290702
      else
          Msg = ' '
      endif
      l2 = min0(Lung(String), 80)
      if (l2.gt.0) then
          Inte = String(1:l2)             !mr 300403
      else
          Inte = ' '
      endif
!
      do i=1,nchar
         Messaggio(i:i) = '*'
      enddo
      if (icode == 1) write(lo,80,err=100) Messaggio(1:nchar)
      call CentraStr(icode,nchar,Messaggio,Inte)

      ki = 1
      kf = Lung(Msg)
      if (nType.eq.SEVERE_ERR_WINDOW) then
          Msg(kf+1:) = char(10) // ProgName(1:lProgName) //
     *                  ' will be terminated!!!'
          kf = Lung(Msg)
      endif
      Msg(kf+1:kf+1) = char(0)
      do while(kf > ki)
         newki = formatta_msgbis(Msg(ki:kf), nchar)
         if(newki.gt.0) then
            nspace = (70 - newki) / 2
            do i=1, nchar
               Messaggio(i:i) = ' '
            enddo
            Messaggio(nspace+1:nspace+newki) = Msg(ki:ki+newki-1)
            if (icode == 1) write(lo,80) Messaggio(1:nchar)
         else
            newki = 1
         endif
         ki = ki + newki
      enddo
!
      if (icode == 1) then
          do i=1,nchar
             Messaggio(i:i) = '*'
          enddo
          write(lo,80) Messaggio(1:nchar)
      endif
   80 format(2x,'*',a,'*')
! ---
      if (kscreen == 1) then       !! si puo' fare??? RS 10.08.08
          l1 = Lung(String)
          l2 = Lung(Msg)
          if (ifAutomatic == 0) then
              call MsgWinErrC(String(1:l1)//char(0), Msg(1:l2)//char(0),
     *                    nType, iExitC)
          else
              call OpenWarning(Msg(1:l2))
          endif
      endif                        !! si puo' fare??? RS 10.08.08
!
      return
  100 l1 = Lung(String)
      l2 = Lung(Msg)
      Msg(l2+1:) = '. Also the directory is write-protected.'
      l2 = Lung(Msg)
      call MsgWinErrC(String(1:l1)//char(0), Msg(1:l2)//char(0),
     *                nType, iExitC)
      return
      end
! ----------------------------------------------------------------------
      subroutine SirTm(time)
      character*(*) time
!
      call mrsirtm(time)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine fGetPWD(string,lstring,ier)
      character*(*) string
!
       lstring = len(string)
       call mrgetpwd(string, lstring, ier)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine fGetProgDir(string,lstring)
      character*(*) string
!
      lstring = len(string)
      call fget_program_directory(string, lstring)
      string(lstring+1:) = ' '

!
      return
      end
! ----------------------------------------------------------------------
      integer function nfGetEnv()
!
      nfGetEnv = mrgetenv()
!
      return
      end
! ----------------------------------------------------------------------
      integer function getCfgDir(cfgdir)
!
      character*(*) cfgdir
      integer get_configdir
!
      getCfgDir = get_configdir(cfgdir, len(cfgdir))
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SpecialChar(SP_Char, stringaSpec, LungstringaSpec)
!
      implicit none
!
      character(len=*)    :: stringaSpec
      integer SP_Char, LungstringaSpec
!
      call spec_char(SP_Char, stringaSpec, len(stringaSpec))
      LungstringaSpec = index(stringaSpec, char(0))-1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CreaPng(nome)
!
      implicit none
!
      character(len=*)    :: nome
      integer             :: k, Lung
!
      k = Lung(nome)
      if (k > 0) then
          call crea_png(nome(1:k) // char(0))
      endif
      return
      end
!-----------------------------------------------------------------------
      subroutine cstop(messaggio)
      USE Molcom
      implicit none

      character*(*) messaggio
!
      call c_stop (messaggio // char(0), ifHidden)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine toflush()
!
      call toflushc()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sfftw_executec2r(n1,n2,n3,FORTHl,xmapCl,xmapl)
      implicit none
      integer*8 FORTHl
      integer*4 n1
      integer*4 n2
      integer*4 n3
      real    xmapl(0:n1-1,0:n2-1,0:n3-1)
      complex   xmapCl(0:n1/2,0:n2-1,0:n3-1)
!
      call sfftw_execute_c2r(n3,n2,n1,FORTHl,xmapCl,xmapl)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sfftw_executer2c(n1,n2,n3,BACKl,xmapl,xmapCl)
      implicit none
      integer*8 BACKl
      integer*4 n1
      integer*4 n2
      integer*4 n3
      real    xmapl(0:n1-1,0:n2-1,0:n3-1)
      complex   xmapCl(0:n1/2,0:n2-1,0:n3-1)
!
      call sfftw_execute_r2c(n3,n2,n1,BACKl,xmapl,xmapCl)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sfftw_executer2c_1d(n1,BACKl,vett,vettC)
      implicit none
      integer*8 BACKl
      integer*4 n1
      real    vett(0:n1-1)
      complex   vettC(0:n1/2)
!
      call sfftw_execute_r2c_1d(n1,BACKl,vett,vettC)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sfftw_execute(BACKel)
!
      implicit none
      integer*8 BACKel
!
      call sfftw_executeC(BACKel)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sfftw_plan_dft_c2r_3d(FORTHl, n1, n2, n3, xmapCl,xmapl,
     *                                        FFTW_ESTIMATEl)
!
      implicit none
      integer*8 FORTHl
      integer*4 n1
      integer*4 n2
      integer*4 n3
      real*4    xmapl(0:n1-1,0:n2-1,0:n3-1)
      complex   xmapCl(0:n1/2,0:n2-1,0:n3-1)
      integer*4 FFTW_ESTIMATEl
      integer*8 sfftw_plan_dft_c2r_3dC
!
      FORTHl = sfftw_plan_dft_c2r_3dC(n1, n2, n3, xmapCl,xmapl,
     *                                        FFTW_ESTIMATEl)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sfftw_plan_dft_r2c_3d(BACKl, n1, n2, n3, xmapl,xmapCl,
     *                                        FFTW_ESTIMATEl)
!
      implicit none
      integer*8 BACKl
      integer*4 n1
      integer*4 n2
      integer*4 n3
      real*4    xmapl(0:n1-1,0:n2-1,0:n3-1)
      complex   xmapCl(0:n1/2,0:n2-1,0:n3-1)
      integer*4 FFTW_ESTIMATEl
      integer*8 sfftw_plan_dft_r2c_3dC
!
      BACKl = sfftw_plan_dft_r2c_3dC(n1, n2, n3, xmapl,xmapCl,
     *                                        FFTW_ESTIMATEl)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sfftw_destroy_plan(PLAN)
!
      implicit none
      integer*8 PLAN
!
      call sfftw_destroy_planC(PLAN)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine dfftw_plan_dft_r2c_1d(PLAN, n, vInp, vOut, FLAG)
!
!-- FLAG = i.e. FFTW_ESTIMATE
!
      implicit none
      integer*4 n
      integer*8 PLAN
!
      real*4    vInp(1:n)
      complex   vOut(1:n)
      integer*4 FLAG
      integer*8 sfftw_plan_dft_r2c_1dC
!
      PLAN = sfftw_plan_dft_r2c_1dC(n, vInp, vOut, FLAG)
!
      return
      end
!-----------------------------------------------------------------------
      logical function EsisteProgramma(prgnam)
!
      implicit none
      character (len=*) prgnam
      integer ires, CEsisteProgramma, Lung
!
      ires = CEsisteProgramma(prgnam(1:Lung(prgnam)) // char(0))
      EsisteProgramma = (ires /= 0)
!
      return
      end
!-----------------------------------------------------------------------
         
