#ifndef MAPS
#define MAPS
#endif
#ifndef HAVE_LEGEND
#define HAVE_LEGEND
#endif
#define JAV_FINAL 1
namespace GLextmr {
     void leggiMTZ(std::string fn);
     void on_OpenGeneral(gpointer item, gpointer data);
     void on_Open1(gpointer item, gpointer data);
     void on_Open1b(gpointer item, gpointer data);
     void on_Open1c(gpointer item, gpointer data);
     void on_Open1d(gpointer item, gpointer data);
     void on_Open2(gpointer item, gpointer data);
     void on_Open3(gpointer item, gpointer data);
     void on_Open4(gpointer item, gpointer data);
     void on_Open5(gpointer item, gpointer data);
     void on_Open6(gpointer item, gpointer data);
     void on_LastRun(gpointer item, gpointer data);
     void on_LoadSmall(gpointer item, gpointer data);
     void on_LoadMacro(gpointer item, gpointer data);
     void on_Close(gpointer item, gpointer data);
     void on_Quit(gpointer item, gpointer data);
     void on_delete(gpointer item, gpointer data);
     void on_global_modify(gpointer item, gpointer data);
     void on_movecxplus(gpointer item, gpointer data);
     void on_movecxminus(gpointer item, gpointer data);
     void on_movecyplus(gpointer item, gpointer data);
     void on_movecyminus(gpointer item, gpointer data);
     void on_moveczplus(gpointer item, gpointer data);
     void on_moveczminus(gpointer item, gpointer data);
     void on_Help(gpointer item, gpointer data);
     void on_ClearLabels(gpointer item, gpointer data);
     void ChangeCentre(gpointer item, gpointer data);
     void PrintInfo(gpointer item, gpointer data);
     void GeneralProperties(gpointer item, gpointer data);
     void on_PeakSearch(gpointer item, gpointer data);
     void on_Elica(gpointer item, gpointer data);
     void on_ViewOutput(gpointer item, gpointer data);
     void open_chelp(gpointer item, gpointer data);
     void update_infos_cell(int ifAny);
     void update_infos_map(int ifDelete);
     void update_infos_model(int whichModel, bool ifNewModel=true);
     void show_dialog(GtkWidget *window, GtkWidget *father);
     void SelectResidue(int x, int y, gpointer data);
     void update_modify_menu(bool ifNewModel=true);
     void AddLegend(gpointer item, gpointer data);
     void ModifyLegend(gpointer item, gpointer data);
     void ShowHideLegend(gpointer item, gpointer data);
     void DeleteLegend(gpointer item, gpointer data);
//     void open_pango();
//     void close_pango();
     void DrawFlag();
//     void DrawText(int width, PangoFontDescription *font_desc, 
//              PangoAlignment alignment, float color[], float xy[], 
//              const char *testo, PangoRectangle *r2, int w=-1, int h=-1);
     bool parse_string(const char *str_in, std::string &str_out);
     void RipassaMappe();
     void on_modify(gpointer item, gpointer data);
     void ViewSequence(int whichModel);
     //void GoToAtom(gpointer item, gpointer data);
     void ListAtomsJ(gpointer item, gpointer data);
     void on_SaveRun (gpointer item, gpointer data);
     void on_LoadRun (gpointer item, gpointer data);
     void on_LoadAscii (gpointer item, gpointer data);
     void on_SaveAscii (gpointer item, gpointer data);
     void update_title(GLWindow *gl, int ifModel);
}
//=========================================================
void open_about_jav(gpointer item, gpointer data);
void open_khelp_jav (gpointer item, gpointer data);
void print_mess(const char *riga);

extern "C" void deletemapsmodels_(int maps[], int models[]);
#ifdef JAV_FINAL
#include "callbacks2d.h"
#endif
