#ifndef NUMSPECIES
#define NUMSPECIES 18
#endif
typedef struct {
                  std::string label;
                  int         indc;
               } _Oggetti;

typedef struct {
                  const char *pkgnam;
                  const char *AppFont;
                  const char *PropFont;
                  const char *FixedFont;
                  int bg;
                  void (*cbFonts)(gpointer p);
                  void (*cbColors)(gpointer p);
                  void (*cbDraw)(gpointer p1, gpointer p2i, gpointer p3);
                  int indcolor[50];
                  GdkColor colorb[N_OBJS+N_ELEMENTS];
                  std::vector<_Oggetti> oggetti;
                  int nSpec;
                  int maxspecies;
                  int nat[NUMSPECIES];
               } _SettingsInfo;

   class Settings
   {
       public:  
          Settings(const _SettingsInfo info, int twin);
          ~Settings();
          std::string pkgnam;
          int whichFont;
          char *fontname;
          std::string AppFont;
          std::string PropFont;
          std::string FixedFont;
          int jbg;
          int indcolor[50];
          GdkColor colorb[16];
          GdkColor CurrentColor;
          GdkColor colori[N_OBJS+N_ELEMENTS];
          rgbCol BaseColors[16];
          GtkToggleButton *old_selected;
          int  ind;
          int  tWin;
          int NumSpec;
          int MaxSpecies;
          int nat[NUMSPECIES];
   };

void open_settings_notebook (GtkWidget* item, _SettingsInfo *info, rgbCol col[]);
