void apri_GLwindow(GtkWidget *item, gpointer data);
gboolean ifMenubar = TRUE;


static mr_action_entry Menu_Items[] = {

{0, 1, "File", "_File", "File Operations", NULL, NULL, NULL, 1, 1}, 
{1, 1, "New", "_New", "Create a new Project", "filenew1", G_CALLBACK(open_newproj_dlg), NULL, -1, 1}, 
{1, 1, "Load & Go", "_Load & Go", "Load input (.sir) file and start the run", "opensir", G_CALLBACK(open_file), NULL, 0, 1}, 
{1, 1, "Old Project", "_Old Project", "Load Project (.bin) file", "openbin", G_CALLBACK(open_file), NULL, 1, 1}, 
{1, 1, "Recent Projects", "_Recent Projects", "Load 1 of 5 projects", "void", NULL, NULL, -1, 1}, 
{2, 1, "recent1", "recent1", "Load this project", NULL, NULL, NULL, -1, 1}, 
{2, 1, "recent2", "recent2", "Load this project", NULL, NULL, NULL, -1, 1}, 
{2, 1, "recent3", "recent3", "Load this project", NULL, NULL, NULL, -1, 1}, 
{2, 1, "recent4", "recent4", "Load this project", NULL, NULL, NULL, -1, 1}, 
{2, 1, "recent5", "recent5", "Load this project", NULL, NULL, NULL, -1, 1}, 
{1, 4},
{1, 1, "Load Examples", "Load Ex_amples", "Load Example (.sir) file and start the run", "opensir", G_CALLBACK(open_file), NULL, 101, 1}, 
{1, 4},
{1, 1, "Import", "_Import", "Import file", "importb", NULL, NULL, -1, 1}, 
{2, 1, "Shelx File (ins)", "S_helx File (*.ins,*.res)", "Shelx File", NULL, G_CALLBACK(open_file), NULL, 6, 1}, 
{2, 1, "PDB (pdb,ent)", "_PDB (*.pdb,*.ent)", "PDB Fragment", NULL, G_CALLBACK(open_file), NULL, 7, 1}, 
{2, 1, "C.I.F. (*.cif)", "C.I.F. (*.cif)", "C.I.F format", NULL, G_CALLBACK(open_file), NULL, 13, 1}, 
{2, 1, "Z-matrix ", "Z-matrix ", "Z-matrix format", NULL, NULL, NULL, -1, 1}, 
{3, 1, "Z-matrix cordinates (*.fhz) in Fenske-Hall standard", "Z-matrix cordinates (*.fhz) in Fenske-Hall standard", "Z-matrix format", NULL, G_CALLBACK(open_file), NULL, 14, 1}, 
{3, 1, "Z-matrix, format (*.mop)", "Z-matrix, format (*.mop)", "Z-matrix mop format ", NULL, G_CALLBACK(open_file), NULL, 15, 1}, 
{1, 1, "Export", "_Export", "File Export", "exportb", NULL, NULL, -1, 0}, 
{2, 1, "Shelx (res)", "_Shelx (*.res)", "Shelx", NULL, G_CALLBACK(c_esporta), NULL, 1, 1}, 
{2, 1, "Crystals (cry)", "_Crystals (*.cry)", "Crystals", NULL, G_CALLBACK(c_esporta), NULL, 2, 1}, 
{2, 1, "Xtal (phs, map)", "_Xtal (*.phs, *.map)", "Xtal", NULL, G_CALLBACK(c_esporta), NULL, 3, 1}, 
{2, 1, "CCP4 (map)", "CCP_4 (*.map)", "CCP_4", NULL, G_CALLBACK(c_esporta), NULL, 4, 1}, 
{2, 1, "PDB (pdb)", "_PDB (*.pdb)", "PDB", NULL, G_CALLBACK(c_esporta), NULL, 5, 1}, 
{2, 1, "Moldraw (mol)", "_Moldraw (*.mol)", "Moldraw", NULL, G_CALLBACK(c_esporta), NULL, 10, 1}, 
{2, 1, "XYZ format (xyz)", "_XYZ format (*.xyz)", "XYZ format", NULL, G_CALLBACK(c_esporta), NULL, 11, 1}, 
{2, 1, "PovRay format (pov)", "Pov_Ray format (*.pov)", "PovRay format", NULL, G_CALLBACK(c_esporta), NULL, 12, 1},
{2, 1, "C.I.F. format (*.cif)", "C.I.F. format (*.cif)", "C.I.F. format", NULL, G_CALLBACK(c_esporta), NULL, 13, 1}, 
{2, 1, "Z-matrix format (*.fhz)", "Z-matrix format (*.fhz)", "Z-matrix format", NULL, G_CALLBACK(c_esporta), NULL, 14, 1}, 
{1, 4},
{1, 1, "Save", "_Save", "Save project file", "save", G_CALLBACK(c_savebinfile), NULL, -1, 0}, 
{1, 1, "Restore", "Res_tore", "Restore project file", "restore", G_CALLBACK(c_restorebinfile), NULL, -1, 1}, 
{1, 4},
{1, 1, "View output file", "_View output file", "View output file", "output", G_CALLBACK(c_browserv2), NULL, 5, 1}, 
{1, 1, "Summary (htm)", "S_ummary (htm)", "Summary of results in htm format", "summary", G_CALLBACK(c_browserv2), NULL, 1, 0}, 
{1, 4},
{1, 1, "HardCopy", "_HardCopy", "Hard Copy", "camera", G_CALLBACK(PrintScreen), NULL, 1, 1}, 
{1, 4},
{1, 1, "Exit", "E_xit", "Exit " MR_PACKAGE, "quit", G_CALLBACK(exit_confirm), NULL, -1, 1}, 

{0, 1, "ViewMenu", "_View", "View using Jav", NULL, NULL, NULL, -1, 0}, 
{1, 1, "Reset View", "Reset _View", "Reset the view", "reset", G_CALLBACK(view_options), NULL, 18, 1},
{1, 3, "Label Atoms", "Label Atoms", "Label Atoms ", "laboff", G_CALLBACK(LabelsOnOff), NULL, -2, 1, 0},
{1, 1, "Plot Style", "Plot _Style", "Change the plot style of selected atoms", "plot_ico", G_CALLBACK(open_cplotstyle_dlg), NULL, -1, 0}, 
{1, 1, "Jav", "Jav", "Open structure in Jav", "jav", G_CALLBACK(call_javs), NULL, -1, 1}, 
{1, 1, "MapViewer", "_MapViewer", "3D contour via Jav", "contour", G_CALLBACK(c_restart), NULL, 3, 1}, 
{1, 1, "Contour", "_Contour", "2D contour", "2D_contour", G_CALLBACK(c_restart), NULL, 4, 1}, 

{0, 1, "Solve", "Solve", "Final Stage Procedures", NULL, NULL, NULL, -1, 0}, 
{1, 1, "Select among the best R% trials", "_Select among the best R% trials", "Recover a model among those with the best R% value", "best_trial", G_CALLBACK(c_best_r), NULL, -1, 1}, 
{1, 1, "Re-compute trial", "R_e-compute trial", "Re-compute atomic model using a previous trial.", "re-compute", G_CALLBACK(c_restart), NULL, 5, 1}, 
{1, 1, "Develop new trials", "_Develop new trials", " Develop new trials", "new_trials", G_CALLBACK(tune), NULL, -1, 1}, 
{1, 1, "Simulated Annealing", "_Simulated Annealing", " Start Simulated Annealing procedure", "sa", G_CALLBACK(c_globalopt), NULL, 0, 1}, 

{0, 1, "Refine", "_Refine", "Refine the structure", NULL, NULL, NULL, -1, 0}, 
{1, 1, "LSQ", "_LSQ", "Least Squares Refinement", "lsq1_ico", G_CALLBACK(c_lsq), NULL, -1, 1}, 
{1, 1, "LSQ info", "L_SQ info", "LSQ info", "lsqinfo_ico", G_CALLBACK(c_browserv2), NULL, 4, 1}, 
{1, 1, "Thermal Factor", "T_hermal Factor", "Delete atoms with a very high thermal factor", "thf_ani2.gif", G_CALLBACK(c_ThFacTooBig), NULL, -1, 1}, 
{1, 1, "Fourier", "_Fourier", "Fourier synthesis", "fourier_ico", G_CALLBACK(open_fourier_dlg), NULL, -1, 1}, 
{1, 1, "Compare Atoms", "C_ompare Atoms", "Compare coords", "compare", G_CALLBACK(compare_atoms), NULL, -1, 0}, 

{0, 1, "Help", "_Help", "Help", NULL, NULL, NULL, -1, 1}, 
{1, 1, "Check for Updates", "Check for _Updates", "Check for updates", "checkforupdate", G_CALLBACK(CheckForUpdates), NULL, -1, 1}, 
{1, 1, "Content2", "_Content (HTML)", "Help on Content", "help_content", G_CALLBACK(system_browser2), NULL, -1, 1}, 
{1, 1, "Documentation(PDF)", "Documentation (PDF)", "Help on Content(PDF file)", "pdf", G_CALLBACK(pdf_open), NULL, -1, 1, 0},
//{1, 1, "Keyboard", "_Keyboard", "Help on Keyboard", "keyb_ico", G_CALLBACK(open_khelp_sir), NULL, -1, 1}, 
{1, 1, "About", "_About", "About " MR_PACKAGE, "info_about", G_CALLBACK(open_about_sir), NULL, -1, 1}
};

static guint n_menu_items = G_N_ELEMENTS (Menu_Items);

static gpointer menuitems = (gpointer) Menu_Items;

#ifdef USE_ACTIONS
static const gchar *menu_info =
"<ui>"
"  <menubar name='MenuBar'>"
"    <menu action='File'>"
"      <menuitem action='New'/>"
"      <menuitem action='Load &amp; Go'/>"
"      <menuitem action='Old Project'/>"
"      <menu action='Recent Projects'>"
"         <menuitem action='recent1'/>"
"         <menuitem action='recent2'/>"
"         <menuitem action='recent3'/>"
"         <menuitem action='recent4'/>"
"         <menuitem action='recent5'/>"
"      </menu>"
"      <separator/>"
"      <menuitem action='Load Examples'/>"
"      <menu action='Import'>"
"         <menuitem action='Shelx File (ins)'/>"
"         <menuitem action='PDB (pdb,ent)'/>"
"         <menuitem action='C.I.F. (*.cif)'/>"
"         <menu  action='Z-matrix '>"
"           <menuitem action='Z-matrix cordinates (*.fhz) in Fenske-Hall standard'/>"
"           <menuitem action='Z-matrix, format (*.mop)'/>"
"         </menu>"
"      </menu>"
"      <menu action='Export'>"
"         <menuitem action='Shelx (res)'/>"
"         <menuitem action='Crystals (cry)'/>"
"         <menuitem action='Xtal (phs, map)'/>"
"         <menuitem action='CCP4 (map)'/>"
"         <menuitem action='PDB (pdb)'/>"
"         <menuitem action='Moldraw (mol)'/>"
"         <menuitem action='XYZ format (xyz)'/>"
"         <menuitem action='PovRay format (pov)'/>"
"         <menuitem action='C.I.F. format (*.cif)'/>"
"         <menuitem action='Z-matrix format (*.fhz)'/>"
"      </menu>"
"      <separator/>"
"      <menuitem action='Save'/>"
"      <menuitem action='Restore'/>"
"      <separator/>"
"      <menuitem action='View output file'/>"
"      <menuitem action='Summary (htm)'/>"
"      <separator/>"
"      <menuitem action='HardCopy'/>"
"      <separator/>"
"      <menuitem action='Exit'/>"
"    </menu>"
"    <menu action='ViewMenu'>"
"      <menuitem action='Reset View'/>"
"      <menuitem action='Label Atoms'/>"
"      <menuitem action='Plot Style'/>"
"      <menuitem action='Jav'/>"
"      <menuitem action='MapViewer'/>"
"      <menuitem action='Contour'/>"
"    </menu>"
"    <menu action='Solve'>"
"      <menuitem action='Select among the best R% trials'/>"
"      <menuitem action='Re-compute trial'/>"
"      <menuitem action='Develop new trials'/>"
"      <menuitem action='Simulated Annealing'/>"
"    </menu>"
"    <menu action='Refine'>"
"      <menuitem action='LSQ'/>"
"      <menuitem action='LSQ info'/>"
"      <menuitem action='Thermal Factor'/>"
"      <menuitem action='Fourier'/>"
"      <menuitem action='Compare Atoms'/>"
"    </menu>"
"    <menu action='Help'>"
"      <menuitem action='Check for Updates'/>"
"      <menuitem action='Content2'/>"
"      <menuitem action='Documentation(PDF)'/>"
//"      <menuitem action='Keyboard'/>"
"      <menuitem action='About'/>"
"    </menu>"
"  </menubar>"
"</ui>";
#endif
