!-----------------------------------------------------------------------
      subroutine scr2_sir
      USE General
      USE Molcom
      USE PhaseModule
      USE Direttive
      USE commandsmod
!
!     common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,del,ks
      common/screen0/ iys0, iysN, iccx, istx, iccy, isty ,nstep, ixs0
!
      character str*80, strtmp*80
!
      if (kscreen.eq.0) return
!
      if (icomat.eq.1) then
          call sirtime(str,icod)
          k = index(fname(1),'.bin') 
          if (icod.eq.0) then
              MessH = ProgName(1:lProgName) //' starts on: ' //
     *                char(10) // fname(1)(1:k-1)
          else
              MessH = str(1:icod) // char(10) //
     *                ProgName(1:lProgName) //' starts on: ' //
     *                char(10) // fname(1)(1:k-1)
          endif
!

          Inte = ProgName(1:lProgName) //' starts on: ' // 
     *           fname(1)(1:k-1)
          call PrintMess(Inte)
!          do i=1,ipcom
!             j=icomq(i,1)
!             k=Lung(allcom(j))
!             allcom(j)(k+1:k+1) = char(0)
!          end do          
          call c_scr2(0, 0, 0, 0, 0, MessH)
       else
! ---
          ii = 0
          do i=1,icomat 
             j=icomq(i,1)
             if (j.ne.10) then
                 ii = ii + 1
                 str=allcom(j)
                 call ucase(str(1:1))
                 call c_scr2(ii, icomat, 0, 0, 0, str)
             endif
         enddo
!
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine scrf2004(kplot, ifbarra)
      USE General
      USE Molcom
      USE PhaseModule
      USE grexpomod
      USE VLDmod
!
      character line*120, cara*20, cara2*20, Patt_or_Tang*10
      character cIterazione*5
      common /BarraLocale/ line, cara, cara2, Patt_or_Tang, cIterazione
!
!-- plot the content of common /atom/
!
      if (kscreen == 0) return
      if (krecy > 100) return
!
      if (ifVLD > 0 .and. ifMDM == 0) then
          nCycleVLD = nCycleVLD + 1
          if (ifMadEnv == 0) then
              call RWind(2)
          endif
      endif
!
      if (ifMadEnv == 0) then
          ifSingle = 0
          call MolPlo(kplot, ifSingle)
          cara2 = ' '
          ncara2 = 1
      else
          if (ntrSv > 0 .and. nSetStored > 0) then
              write(cara2,50) ntrSv, nSetStored
              call NoBlanks(cara2,ncara2)
          else
              cara2 = ' '
              ncara2 = 1
          endif
      endif
!
      if (ifbarra.eq.0) then
          rfac  = erre  * 100.0
          rfaco = erreo * 100.0
          k = numbrun
          if (ifVLD == 1) then
              k = nPreviousTrials + numbrun
          endif
          write(cara,30) k
          call NoBlanks(cara,icara)
          if (ifVLD == 0 .or. ifMDM == 1) then
              if (ifRidotta == 0) then
                  if (krecy.eq.1) then
                      write(Message,10) cara(1:icara),cara2(1:ncara2),
     *                                  krecy, rfac,FinalFom ! FOMs(2,4)
                  else
                      write(Message,20) cara(1:icara),cara2(1:ncara2),
     *                                  krecy, rfac,rfaco,FinalFom ! FOMs(2,4)
                  endif
              else
                  if (krecy.eq.1) then
                      write(Message,11) cara(1:icara),cara2(1:ncara2),
     *                                  krecy, rfac
                  else
                      write(Message,21) cara(1:icara),cara2(1:ncara2),
     *                                  krecy, rfac,rfaco
                  endif
              endif
          else
              rfaco = erreBestVLD * 100.0
              if (nCycleVLD == 1 .or. erreBestVLD > 9998) then
                  write(Message,12) cara(1:icara),cara2(1:ncara2),
     *                              nCycleVLD, rfac
              else
                  write(Message,22) cara(1:icara),cara2(1:ncara2),
     *                              krecy, rfac, rfaco, nCycleVLD
              endif
          endif
          line = Message(1:Lung(Message))
          if (ifVLD == 0) then
              call scrper(line, 0, -1)
          else
              call scrper(line, jpercBarra, npercBarra)
          endif
      endif
   10 format('Trial ',a,' ',a,' Cycle ',i2,'   R =',f7.2,
     *       '%  Final FOM = ',f7.2)
   11 format('Trial ',a,' ',a,' Cycle ',i2,'   R =',f7.2,'%')
   12 format('VLD: Trial ',a,' ',a,' Lsq cycle ',i2,'   R =',f7.2,'%')
   20 format('Trial ',a,' ',a,' Cycle ',i2,'   R =',f7.2,
     *       '%   (prev. =',f7.2,'%)  FinalFOM =',f7.2)   !pg140906
   21 format('Trial ',a,' ',a,' Cycle ',i2,'   R =',f7.2,
     *       '%   (previous =',f7.2,'%)')
   22 format('VLD: Trial ',a,' ',a,' Lsq cycle ',i4,'   R =',f7.2,
     *       '%   (best =',f7.2,'%). Total number of Lsq cycles: ',i4)
   30 format(i6)
   50 format('(',i5,'/',i5,')')
!
      return
      end
!-----------------------------------------------------------------------
      subroutine scrend(line,lline)
      USE General
      USE Html
      USE Molcom
!
      character line*(*)
!
      nSecs = nint(Secs)
      nSecsPr = nSecs
!
      call sirdate(Inte,icod)
      HTMLend = Inte(1:Lung(Inte)) // ' ' // 
     *          ProgName(1:lProgName) // ' ends'
      call sirtime(Inte,icod)
      if (nSecs.lt.nSecsPr ) then
         nSecs = nSecs + 24 * 3600
      end if
      nSecsTot = nSecs - nSecsPr
      if (icod.gt.0) then
            Msg(1:icod)=Inte(1:icod)
            Msg(icod+1:icod+lline)=line(1:lline)
            lline=icod+lline
            line(1:lline)=Msg(1:lline)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine lastplot(rfac)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Html
      USE PhaseModule
!
      common/screen0/ iys0, iysN, iccx, istx, iccy, isty ,nstep, ixs0
      common /emap1/ fwhm,nngr11,npar11,ffmin,ffmax
!
      character *20  BestMsg(4)
      character*9 cara
!
      ksize = ksize_vero    ! per via di MDM, VLD
!
      if (kmad == 0) then
          ifNoDraw = 0
      endif
      if (nolsq == 0) then
          errem = 10000 + fomBest
          erre  = 10000 + fomBest
          numbrunSav = numbrun
          numbrun = TrBestfom
          call PutGetBackUpXyzs(1)
          numbrun = numbrunSav
      endif
      if (errem.gt.9000) then
          errem = erre
      endif
      erremsav = errem
      rfac=-1.0
      if (kscreen.eq.0) return
!
      if (InfoOK(5) == 1) then
          lix6 = InfoOK(6)
          if (lix6.gt.0) then
              call LoadReflInfo
              if (ifReduced.eq.1) then
                  nreflDim = nrefltot * nsymTrue
              else
                  nreflDim = nrefltot
              endif
              erres = rflsq / 100.0
              if (erres.gt.0.0) errem = erres
          else
              erres = 0.0
          endif
      endif
      call PutGetXyzs(2,interp)
*gl*  call GetModel()   ! da verificare se GetModel o sfl15
***   if (ksize.gt.3.or.nats.gt.500) then
!          call BuildBonds(1)
!          call LEtoIconn
!!!!        iconn(1) = -1
***	    iconn(1) = -9999
***       interp = 0
***	else
***       interp = 1
***	endif
!
      kact=5
      call build(kact, 2)
!
      BTot(1,1) = 101.
      interp = 1
      errem = erremsav
      call PutGetXyzs(1, interp)
      if (ksize <=3) then
          jab = 6
          iPlotType = jab
          SinglePlotType(1:nats) = jab
      else
          jab=3
      endif
      call zflush
!
      rfac = errem*100.0
      if (abs(fomBest).gt.9998) then
          BestMsg(1) = ' n.a. '
      else
          write(cara,'(2h(#,i6,1h))') nint(TrBestfom)
          call NoBlanks(cara,icara)
          write(BestMsg(1),'(f6.2,1x,a)') fomBest,cara
      endif
      if (abs(erreBest).gt.9998) then
          BestMsg(2) = ' n.a. '
          BestMsg(4) = ' '
          msg4 = 1
      else
          write(cara,'(2h(#,i6,1h))') nint(TrerreBest)
          call NoBlanks(cara,icara)
          if (ifRecovered == 0) then
              erreB = erreBest ! gianluca 16/03/2009* 100
              write(BestMsg(4),'(10h in trial ,i6)') numbrun
          else
              if (kmad == 0) then
                  erreB = erreBest ! gianluca 16/03/2009 * 100.0
              else
                  erreB = erreBest
              endif
              write(BestMsg(4),'(10h in trial ,i6)') nint(TrerreBest) ! numbrun
          endif
          write(BestMsg(2),'(f6.2,1x,a)') erreB, cara
          msg4 = Lung(BestMsg(4))
      endif
      if (errem > 9998.0 .or. nint(errem) == -1) then
          BestMsg(3) = ' n.a. '
      else
          write(BestMsg(3),'(f6.2)') errem * 100.
      endif
      if (rfac.gt.0.1) then
          msg1 = Lung(BestMsg(1))
          msg2 = Lung(BestMsg(2))
          msg3 = Lung(BestMsg(3))
!pg080906
          if (ifVLD == 0) then
              if (kmad /= 1) then
                  write(Msg,919) BestMsg(3)(1:msg3),BestMsg(4)(1:msg4),
     *                           BestMsg(1)(1:msg1),BestMsg(2)(1:msg2)
               else
                  write(Msg,920) BestMsg(3)(1:msg3),BestMsg(4)(1:msg4),
     *                           BestMsg(1)(1:msg1)
               endif
           else
               write(Msg,921) BestMsg(3)(1:msg3),BestMsg(4)(1:msg4),
     *                        BestMsg(2)(1:msg2)
           endif
 919      format(' R% = ',a,a,10x,
     *           'Best Final FOM = ',a,'     Best R% = ',a)
 920      format(' R% = ',a,a,10x,
     *           '  Final FOM = ',a)
 921      format(' R% = ',a,a,10x,'     Best R% = ',a)
!pg080906
      else
          Msg = ' '
      endif
      if (ifWasRemo == 1) then
          Msg = ' '
      endif 
!
      call PrintMess(Msg)
!
      BTot(1,1) = 101.
      ifSingle = 0
      call MolPlo(jab, ifSingle)
!pg080906
      if (kmad == 1) then
         call PutGetBackUpXyzs(2)
      end if
!pg080906
      call scrper(Msg,0,-1)
      errem100 = errem * 100.0
      if (LowRes == 0) then
          if (TotalScan == 0 .or. nScan == TotalScan) then
              if (errem100 < RSoglia .and. jrest == 0) then
                  if (neutro == 0 .and. ifMadEnv == 0) then
                      if (ifMinimize == 0) then
                          call wow()
                      endif
                  endif
              endif
          endif
      endif
      call DoSingleIteration()
      call zflush
!
      if (kmad == 0 .and. ifMadEnv == 0) then
          k1 = index(fname(1), '.bin') - 1
          Inte = fname(1)(1:k1) // '_fPlot.png' // char(0)
          call CreaPng(Inte)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine upcard(nAddComm,line,lung,ier)
!
!-- this subroutine update the command queue  (icomq)
!-- and the card reader (card)
!
      USE General
      USE Direttive
      USE commandsmod
!
      character linc*256,line*(*)
!
      call shift(line,lenp)
      if (lenp.eq.0) return
      nallc=40
      linc(1:lung)=line(1:lung)
      if (lung.lt.256) then
          do 100 i=lung+1,256
  100        linc(i:i)=blank
      endif
      if (linc(1:1).eq.beg) then
          icom=0
          do 150 i=1,nallc
             if (linc(2:4).eq.allcom(i)(1:3)) icom=i
  150     continue
          if (icom.eq.0) call cstop('7777')
          nAddComm=nAddComm+1
          icomat=icomat+1
          icomq(icomat,1)=icom
          icomq(icomat,2)=0
          ipcom=ipcom+1
      else
          ipdir=ipdir+1
          if (ipdir.gt.50) go to 500
          card(ipdir)=linc
          icomq(icomat,2)=icomq(icomat,2)+1
      endif
      return
  500 continue
      ier=-1
      ipdir=ipdir-1
      write(lo,510)
  510 format(' more than 50 directives generated ',/,
     *       ' reduce the number of reflections to modify')
      return
      end
!-----------------------------------------------------------------------
      subroutine svcard(nAddComm,ier)
!
!-- this subroutine save the command queue  (icomq)
!-- and the card reader (card)
!-- in the scratch file iscra
!
      USE General
      USE Direttive
      USE commandsmod
!
      character*80 name
!
      ipd=ipdir
      nAddComm=0
      itype=1
      iform=2
      jop=jopen(iscra ,name,itype,iform,ier)
      if (jop.lt.0) go to 9000
!
      ico=icomat
   10 continue
      ico=ico+1
      write(iscra) (icomq(ico,j),j=1,2)
      icom =icomq(ico,1)
      if (icom.eq.0.or.icom.eq.7) go to 30
      icmx=icomq(ico,2)
      ic=0
   20 ic=ic+1
      if (ic.gt.icmx) go to 10
      ipd=ipd+1
      write(iscra) card(ipd)
      go to 20
!
   30 continue
      return
 9000 continue
      write(lo,9020) ier,iscra
 9020 format(' *** error ***  open error on scratch file iscra, code ='
     *,i5,',  channel =',i5)
      ier=-1
      return
      end
!-----------------------------------------------------------------------
      subroutine rscard(nAddComm,iPdire)
!
!-- this subroutine restore the command queue  (icomq)
!-- and the card reader (card)
!-- reading informations from the scratch file iscra
!
      USE General
      USE Direttive
      USE commandsmod
!
      rewind iscra
      ico=icomat
   10 continue
      icomat=icomat+1
      read(iscra) (icomq(icomat,j),j=1,2)
      icom =icomq(icomat,1)
      if (icom.eq.0.or.icom.eq.7) go to 30
      icmx=icomq(icomat,2)
      ic=0
   20 ic=ic+1
      if (ic.gt.icmx) go to 10
      ipdir=ipdir+1
      read(iscra) card(ipdir)
      go to 20
!
   30 continue
      icomat=ico-nAddComm
      ipdir=iPdire
!-- TEST ONLY
!     ipd=ipdir
!     i = icomat
!     write(lo,3) icomat,ipd
!     do ii=1,100
!        i = i + 1
!        j=icomq(i,1)
!        if (j.ne.7) then
!            jj=icomq(i,2)
!            do l=1,jj
!               ipd=ipd+1
!               ll = lung(card(ipd))
!               if (ll.le.0) ll=1
!               if (i.eq.icomat) then
!                   write(lo,1) i,ipd,allcom(j),card(ipd)(1:ll)
!               else
!                   write(lo,2) i,ipd,allcom(j),card(ipd)(1:ll)
!               endif
!            enddo
!        else
!            write(lo,2) i,ipd,allcom(j)
!        endif
!     enddo
!   1 format(2i5,2h >,a14,a)
!   2 format(2i5,2h  ,a14,a)
!   3 format(2i5,' ============================================')
!
      close (iscra)
      return
      end
!-----------------------------------------------------------------------
      subroutine MoveTables(ier)
      USE General
!
      character*80 line
! ---
      ier = 0
      rewind jrel
      rewind iscra
      do
         read(jrel,'(a)',end=200) line
         write(iscra,'(a)') line
      enddo
!
  200 continue
!
      return
      end
c-----------------------------------------------------------------------
      subroutine LoadFromBin(file1,file2,ier)
      USE General
      USE Molcom
      USE PhaseModule
!
      implicit none
      integer :: ier, k, icod, L, Lung, kplot, ifSingle, interp, init
      integer :: itype, iform, jop, jopen, ier2, NewFileBin
      character *80 str
      character *(*) file1, file2
!
      MessH = 'Data loaded from ' // file1(1:Lung(file1))
      call PrintMess(MessH)
      fname(1) = file1
      k=index(fname(1),'.')
      call sirtime(str,icod)
      if (icod.eq.0) then
          MessH = ProgName(1:lProgName) //' starts on: ' //
     *            char(10) // fname(1)(1:k-1)
        else
          MessH = str(1:icod) // char(10) //
     *            ProgName(1:lProgName) //' starts on: ' //
     *            char(10) // fname(1)(1:k-1)
      endif
!
      itype = 0
      iform = 1
      if (file2(1:1).ne.' ') then
          jop = jopen(lo,file2,itype,iform,ier2)
          if (jop.lt.0) then
              ier = -1
              write(lo,10) ier2,file2(1:Lung(file2))
              return
          endif
      endif
!
      init = 0
      call SucchiaDati(init,NewFileBin,ier)
      if (ier.lt.0) then
          return
      endif
      write(lo,20) Titolo
      call wrhead
      write(lo,30)
      call summar(ier)
!
      if (InfoOK(5).eq.1.or.InfoOK(15).eq.1) then
          kplot = iPlotType
          ifSingle = 1
          call MolPlo(kplot, ifSingle)
          interp = 1
          call PutGetXyzs(1, interp)
      endif
!
      MessH = 'Data loaded from ' // file1(1:Lung(file1))
      L = Lung(MessH)
      write(Inte,40) errem*100, numbrun
      Msg = MessH(1:L) // Inte
      call OneBlankOnly(Msg)
      call PrintMess(Msg)
      call DoSingleIteration()
!
      return
   10 format(' *** error ***  open error, code =',i5,' file is ',a)
   20 format(' ',78('*'),/,' ',a,//)
   30 format(6x,'Project file actually contains:'/)
   40 format(': R% = ',f8.2,2x,'in trial',i5)
      end
c-----------------------------------------------------------------------
      subroutine PrintNoWindow(erreNoWind, fomNoWind)
      USE General
      USE Molcom
      USE PhaseModule
      USE VLDmod_3
!
      implicit none
      integer :: enne, icara, icara0, Lung, msg1, msg2, msg3
      real    :: erreNoWind, fomNoWind, rfac
      character (len=22) :: BestMsg(3)
      character (len= 9) :: cara
      character (len=20) :: cara0
!
      if (ifVLD == 0) then
          enne = ntrSv
      else
          enne = numero_cicli
      endif
      write(cara0,10) numbrun
      call NoBlanks(cara0,icara0)
      rfac = erreNoWind*100.0
      if (abs(fomBest).gt.9998) then
          BestMsg(2) = ' n.a. '
      else
          write(cara,'(2h(#,i6,1h))') nint(TrBestfom)
          call NoBlanks(cara,icara)
          write(BestMsg(2),'(6h Best=,f6.2,a)') fomBest,cara
      endif
      if (abs(erreBest).gt.9998) then
          BestMsg(1) = 'Best n.a'
      else
          write(cara,'(2h(#,i6,1h))') nint(TrerreBest)
          call NoBlanks(cara,icara)
          write(BestMsg(1),'(6h Best=,f6.2,a)') erreBest, cara
      endif
      if (erreNoWind.gt.9998) then
          BestMsg(3) = ' n.a. '
      else
          write(BestMsg(3),'(f8.2)') erreNoWind * 100.
      endif
      if (rfac.gt.0.1) then
          msg1 = Lung(BestMsg(1))
          msg2 = Lung(BestMsg(2))
          msg3 = Lung(BestMsg(3))
          if (kmad /= 0) then
             write(Msg,20) enne,cara0(1:icara0),BestMsg(3)(1:msg3),
     *                   BestMsg(1)(1:msg1),fomNoWind,BestMsg(2)(1:msg2)
          else
             write(Msg,30) enne,cara0(1:icara0),BestMsg(3)(1:msg3),
     *                   BestMsg(1)(1:msg1),fomNoWind,BestMsg(2)(1:msg2)
          end if
      else
           Msg = ' '
      endif
!
      if (if97 == 0) then
          write(0,'(a)') Msg(1:Lung(msg))
      endif
!
   10 format(i6)
   20 format(i5,' Trial ',a,'  R% =',a,2x,a,'  R%/FOM = ',f7.2,a)
   30 format(i5,' Trial ',a,'  R% =',a,2x,a,'  FOM = ',f7.2,a)
!
      return
      end
!======================================================================
!
!  --------------------- S C R E E N 2 0 0 3  ----------------------
!
!======================================================================
      subroutine scr0(nkscrx,nkscry)
      USE General
      USE Molcom
      USE commandsmod
!
      common/screen0/ iys0, iysN, iccx, istx, iccy, isty ,nstep, ixs0
      common /SizeScr/ MinScX, MaxScX, MinScY, MaxScY
!
      character *80 Messaggio
      character *256 str
!
      if (kscreen.eq.0) return
!
!-- open the window
!
      ixv(1) = kscrx
      iyv(1) = kscry
      ixv(2) = 0
      ixv(3) = SIRPGM
!gl!  write(str,'(20a4)') itle
      str = Titolo
      call shift(str,lstr)
      iz=lstr
      Messaggio = '  ' // ProgName(1:lProgName)
      lm = Lung(Messaggio)
! ---
      izz = 79 - lm
      MessH = Messaggio(1:lm) // ': ' // str(1:izz)
      call OpenWindow(MessH, iz)
      if (iz.lt.0) then
         kscreen=0
         if (ifDebug == 0) then
             call manage_console(1)
             ifDebug = 1
         endif
         write(0,*) 
         write(0,*) '*******************************************' 
         write(0,*) '*    The Display cannot be accessed !!!   *' 
         write(0,*) '*                                         *' 
         write(0,*) '*  Program will go on without graphics    *'
         if (fname(14)(1:1).eq.'.')
     *   write(0,*) '* only if a input file has been supplied  *'
         write(0,*) '*******************************************' 
         write(0,*) 
         call manage_console(2)
         return
      end if
      kscrx=ixv(1)
      kscry=iyv(1)
      FntPixWidth = ixv(2)
      FntPixHeight = iyv(2)
      FntAscent = ixv(3)
      FntDescent = iyv(3)
      MaxScX = ixv(5)
      MaxScY = iyv(5)
!
      ifLabels = ixv(7)
      iPlotType = ixv(8)
      jBackGround = iyv(8)
      icoWire = 1 - jBackGround
! ---
      jpatterntype = ixv(9)
      jmarkertype = iyv(9)
      jsizemarker = ixv(10)
      klegend = iyv(10)
! ---
!mr191009      call AllocaColori()
! ---
      jscreen = 1
! ---
      iVP(1) = 1
      iVP(2) = 1
      iVP(3) = kscrx
      iVP(4) = kscry
!
!-- draw the Header
!
      Msg = fname(1)
      k = index(Msg,'.')
      if (k.eq.1) then
          k = 2
          Msg = '.'
      endif
      call sirtime(str,icod)
      if (icod.eq.0) then
          MessH = ProgName(1:lProgName) //' starts on: ' //
     *            char(10) // Msg(1:k-1)
        else
          MessH = str(1:icod) // char(10) //
     *            ProgName(1:lProgName) //' starts on: ' //
     *            char(10) // Msg(1:k-1)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine scrper(line,iperc,nperc)
      USE General
      USE Molcom
!
      character line*(*)
!
      if (kscreen.eq.0) return

!     tmp = line
!     write(lo,7777) tmp(1:40),iperc,nperc
!7777 format('scrper ',a40,2i5)
!
      lline = Lung(line)
!mr080904      if (iperc.eq.0) then
*     if (iperc.eq.0.and.nperc.eq.0) then
      if (iperc.eq.0.and.nperc.le.0) then
        iz=0
        ind = 3
        call BarraDiStato(iz,ind,ix,iy,' ')
      endif
c
      if (lline.gt.0) then
          Message = ' '
          Message(1:lline) = line(1:lline)
          call PrintMess(Message)
      endif
c
      if (iperc.eq.0) then
!mr080904          if (nperc.eq.0) then
          if (nperc.ge.0) then
              iz=0
              ind = 2
              call BarraDiStato(iz,ind,ix,iy,' ')
          endif
      else
           ix = iperc
           iy = nperc
           iz=5
           ind = 1
           call BarraDiStato(iz,ind,ix,iy,' ')
      endif
!
!mr   call zflush
      call DoSingleIteration()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine BeccaSt(ier,file1,file2,filen,nomeStr,NumArgs)
      USE General
      USE Molcom
!
      common/testoutput/ koutput
!-- graphics
      common /statico/ xx1,xx2,yy1,yy2,Escurs,OldVal
      dimension nMaxChar(4), ift(4)
      character*(*) file1,file2,filen,nomeStr
      character *20 Desc(4), NewField(4)
      character*256 bfile1
      integer opened1,opened2
!
      opened1 = 0
      opened2 = 0
      nomeStr = ' '
!--
      call BeccaArg(file1,file2,NumArgs)
      if (file1(1:7).eq.'newproj') then
!mr       if (file2(1:1).eq.'1') then
!mr           kktest = 1
!mr       else
!mr           kktest = 0
!mr       endif
          file2 = ' '
          nomeStr = ' '    
          return
      endif
!--
      if (QualePgm == SIRPGM) then
          input_ext = '.sir'
      else 
         input_ext = '.exp'
      endif
      input_ext(5:5) = char(0)
      if (file1(1:1).ne.' ') then
          call cBaseName(file1, bfile1)
          filen = file1
*         call lcase(filen)
          jsir = index(bfile1,'.'      )
          if (jsir /= 0) then
              k = jsir - 1
              nomeStr = bfile1(1:k)
          else
              nomeStr = file1
              k = Lung(nomeStr)
              file1 = nomeStr(1:k) // input_ext(1:4)
              k = Lung(bfile1)
              nomeStr = bfile1(1:k)
          endif
          itype=2
          iform=1
          jop=jopen(ln,file1,itype,iform,ier1)
          if (jop.lt.0) then
             ier=-2
             write(lo,500) ier1,file1(1:Lung(file1))
             if (ifW95 == 1) then
                 call manage_console(1)
             endif
             write(0,600) ier1,file1(1:Lung(file1))
             if (ifW95 == 1) then
                 call cpause(' ')
                 call manage_console(2)
             endif
          endif
          if (jop >= 0) then
              opened1 = 1
              close(ln)
          endif
          if (file2(1:5).eq.'%test') then
              koutput = 1
              file2 = ' '
          endif
          if (file2(1:1).eq.' ') then
             file2=nomeStr(1:k)//'.out'
          end if
          filen=nomeStr(1:k)//'.bin'
      endif
      if (file2(1:1).eq.' ') then
          if (nomeStr(1:1).ne.' ') then
              k=lung(nomeStr)
              file2=nomeStr(1:k)//'.out'
          endif
      endif
!--
      if (ier.lt.0) then
          return
      endif
!----
      itype = 0
      iform = 1
      if (koutput.eq.0.and.file2(1:1).ne.' ') then
          jop = jopen(lo,file2,itype,iform,ier2)
          if (jop.lt.0) then
              ier = -1
              write(lo,500) ier2,file2(1:Lung(file2))
          endif
      endif
! ---
      if (opened1.eq.1) then
          iTipo = 1            ! iTipo = 1 se file1=*.sir
                               ! iTipo = 2 se file1=*.bin
          call updSWRC(iTipo,file1,file2)
      endif
!
  500 format(' *** error ***  open error, code =',i5,' file is ',a)
  600 format('       ******** Error ******** ',/,
     *       '       Open error, code =',i5,/,
     *       '       file is ',a,/,
     *       '       *********************** ',/)
!
      fname(14) = file1
      fname(15) = file2
!
      return
      end
!-----------------------------------------------------------------------
      subroutine BeccaArg(file1,file2,NumArgs)
      USE General
*     USE F90_UNIX_ENV                  ! NAG f95 Compiler
      USE Molcom
!
      implicit none
      integer :: iargcc, NumArgs, i, ifMacro, Lung
      character (len=*)  ::  file1, file2
      character (len=80) ::  line
      character (len=256) :: args(10), argv, NewL, DISPLAY
      common /Args/ iargcc, args
!
!-- gestione --macro
!
      ifMacro = 0
      if (args(2)(1:2) == '--') then

          call lcase(args(2))
          if (args(2)(1:7) == '--macro') then
              ifMacro = 1
          endif
          iargcc = iargcc - 1
          args(2) = args(3)
          args(3) = args(4)
      endif
!
      NumArgs = iargcc - 1
      if (NumArgs == 2) then
          file1 = args(2)
          file2 = args(3)
      else if (NumArgs == 1) then
          file1 = args(2)
          file2 = ' '
      else
          file1 = ' '
          file2 = ' '
      end if
      do i=1, NumArgs+1
         argv = args(i)
         if (i == 1) then
            exepath = args(1) // char (0)
         else
            call PassaParametro(i, argv)
         endif
!!mr
         if (i == 2) then
             file1 = argv
         else if(i == 3) then
             file2 = argv(1:Lung(argv))
         endif
!!end mr
      enddo
!
!
!-- Get the value of exepath = sir2002.exe directory
!
      call fGetProgDir(exepath, i)
!      write(0, *) 'exepath ', exepath
!      write(0, *) 'file1, file2 ', file1, file2
!
      return
      end
!-----------------------------------------------------------------------
      subroutine updSWRC(iTipo,file1,file2)
      USE General
      USE Molcom
!
! --- iTipo = 1 se file1=*.sir
! --- iTipo = 2 se file1=*.bin
      character *(*) file1,file2
      character *256 line
      character*5 Uinput_ext
!
!!22/07/2016
      if (NOCFG == 1) then
         return
      endif
!! END 22/07/2016
      if(iTipo.eq.1) then
         kTipo = index(file1, input_ext(1:4)) - 1
         if (kTipo == -1) then                        !mr caso ".SIR"
             Uinput_ext(1:4) = input_ext(1:4)
             call ucase(Uinput_ext(1:4))
             kTipo = index(file1, Uinput_ext(1:4)) - 1
         endif
      else
         kTipo = index(file1, '.bin') - 1
      endif
      itype=2
      iform=1
      jop=jopen(jrel,SWRC,itype,iform,ierr)
      if (jop.lt.0) then
          write(lo,500) ierr,SWRC(1:Lung(SWRC))
      else
          itype=1
          iform=1
          jop=jopen(jhost,' ',itype,iform,ierr)
          if (jop.lt.0) then
              write(lo,600) ierr,jhost
          else
            do 100 i=1,10000
               read(jrel,'(a)',err = 50, end = 200) line
   50          write(jhost,'(a)') line
  100       continue
  200       continue
            rewind jhost
            rewind jrel
!-Program version
            read(jhost,'(a)',err=205,end=400) line
  205       write(jrel,'(a)',err=410) line(1:Lung(line))
!-Home Directory
            read(jhost,'(a)',err=210,end=400) line
  210       write(jrel,'(a)',err=410) HOMEdir(1:Lung(HOMEdir))
!-Internet Browser
            read(jhost,'(a)',err=220,end=400) line
  220       write(jrel,'(a)',err=410) line(1:Lung(line))
!-PovRay
            read(jhost,'(a)',err=225,end=400) line
  225       write(jrel,'(a)',err=410) line(1:Lung(line))
!-Default Groups File
            read(jhost,'(a)',err=227,end=400) line
  227       write(jrel,'(a)',err=410) line(1:Lung(line))
!-Working directory & structure name
            call fGetPWD(WorkingDirectory,lstring,ier)
            read(jhost,'(a)',err=230,end=400) line
  230       write(jrel,'(a)',err=410) WorkingDirectory(1:lstring)
            read(jhost,'(a)',err=240,end=400) line
  240       write(jrel,'(a)',err=410) file1(1:kTipo)
!-Output file
            read(jhost,'(a)',err=250,end=400) line
  250       write(jrel,'(a)',err=410) file2(1:Lung(file2))
!-Fonts etc.
            do 300 i=1,10000
               read(jhost,'(a)',end = 400,err=260) line
  260          write(jrel,'(a)',err=410) line(1:Lung(line))
  300       continue
  400       continue
  410       close(jhost)
            close(jrel)
          endif
      endif
  500 format(' *** error ***  open error, code =',i5,' file is ',a)
  600 format(' *** error ***  open error, code =',i5,', unit # ',i5)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine updRecentProjects
      USE General
      USE Molcom
!
      common /RecentPr/ nRecentProjects, RecentProj(5)
      character *256 RecentProj
!
      character *80 WorkingDir,file1,file2
      character * 256 MostRecent, line
!
      close(jhost)
      close(jrel)
!
!!22/07/2016
      if (NOCFG == 1) then
         return
      endif
!! END 22/07/2016
!
      k = index(fname(1), '.bin')
      if (k.eq.1) then
          return
      endif
!
      itype=2
      iform=1
      jop=jopen(jrel,SWRC,itype,iform,ierr)
      if (jop.lt.0) then
          write(lo,500) ierr,SWRC(1:Lung(SWRC))
      else
          itype=1
          iform=1
          jop=jopen(jhost,' ',itype,iform,ierr)
          if (jop.lt.0) then
              write(lo,600) ierr,jhost
          else
              do i=1,10000
                 read(jrel,'(a)',end = 200) line
	         if (i.eq.12) then
                     read(line,*,err=100) iPlt,ksx,ksy,
     *                                  iBe,idum,jBG, ifLab
  100                write(line,'(10i5)',err=400) iPlt,ksx,ksy,
     *                                  iBe,idum,jBG, ifLab
                 else if (i.eq.13) then
                     read(line,*,err=101) jpatterntype, jmarkertype,
     *                           jsizemarker,klegend
  101                write(line,'(4i5)',err=400) jpatterntype,
     *                         jmarkertype,jsizemarker,klegend
                 endif
                 write(jhost,'(a)',err=400) line
              enddo
  200         continue
              rewind jhost
              rewind jrel
!
!mr300903     do i=1,10
              do i=1,13
                 read(jhost,'(a)') line
                 write(jrel,'(a)',err=400) line(1:Lung(line))
                 if (i.eq.6) then
                     MostRecent = line(1:Lung(line)) // 
     *                            slash //
     *                            fname(1)(1:Lung(fname(1)))
                 endif
              enddo
              kMost = Lung(MostRecent)
              write(jrel,'(a)',err=400) MostRecent(1:kMost)
              RecentProj(1)(1:kMost) = MostRecent(1:kMost)
              RecentProj(1)(kMost+1:kMost+1) = char(0)
              imr = 1
!             do while(imr.le.4)
              do i = 1, 4
                 read(jhost,'(a)') line
                 lline = Lung(line)
                 if (line(1:lline).ne.MostRecent(1:kMost)) then
                     write(jrel,'(a)',err=400) line(1:lline)
                     imr = imr + 1
                     RecentProj(imr)(1:lline) = line(1:lline)
                     RecentProj(imr)(1+lline:1+lline) = char(0)
                 endif
              enddo
              if ((nRecentProjects.lt.5).and.(imr.eq.5)) then
                  nRecentProjects = nRecentProjects+1
              endif
              read(jhost,'(a)',end = 300) line
              if (imr.ne.5) then
                 lline = Lung(line)
                 write(jrel,'(a)',err=400) line(1:lline)
              endif
              do i=1,10000
                 read(jhost,'(a)',end = 300) line
                 lline = Lung(line)
                 write(jrel,'(a)',err=400) line(1:lline)
              enddo
  300         continue
  400         close(jhost)
              close(jrel)
          endif
          call UpdateMenu()
      endif
  500 format(' *** error ***  open error, code =',i5,' file is ',a)
  600 format(' *** error ***  open error, code =',i5,', unit # ',i5)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RWind(iAction)
      USE General, only : Inte, StructureName, lStructureName
      USE Molcom
      Use PhaseModule, only : erre, nTotBlocksPh, numbrun, ifVLD
      USE grexpomod
      USE VLDmod
      USE VLDmod_3, only : numero_cicli
!
!--  Action = 0 allocate
!--         = 1 clear plot
!--         = 2 add value to plot
!
      implicit none
      integer, dimension(0:6) :: vcolor
      integer                 :: i, iAction, nGrafico, MaxTrials, pcol
      real                    :: rFac
!
      if (jscreen == 0) return
!
      if (ifVLD == 0) then
          MaxTrials = nTotBlocksPh
      else
          MaxTrials = 1
      endif

      if (iAction == 0 .and. firstTime == 1) then
          firstTime = 0
          Inte = StructureName(1:lStructureName) // 
     *           ': R% vs. number of LSQ cycles'
          call gr_open_viewer(500, 270, Inte, newv=.true.)
          call gr_select_viewer(1)
          call gr_setbackground(color_BRIGHTWHITE)
          call gr_select_viewer(0)
          vcolor = (/color_BROWN,color_LIGHTBLUE,color_LIGHTRED,
     *              color_LIGHTGREEN, color_LIGHTCYAN,
     *              color_LIGHTMAGENTA, color_YELLOW/)
          call gr_create_graph(grgraph)
          call gr_set_graph(grgraph,stringx='LSQ Cycles', stringy='R%',
     *                      spacex=0.05)
          if (allocated(grplot)) then
              if (size(grplot) /= MaxTrials) then
                  deallocate(grplot)
                  allocate(grplot(MaxTrials))
              endif
          else
              allocate(grplot(MaxTrials))
          endif
          do i=1,MaxTrials
             call gr_new_plot(grplot(i),100)
             pcol = mod(i,size(vcolor))
             call gr_set_plot(grplot(i),colorline=vcolor(pcol))
          enddo
      elseif (iAction == 1) then
          nGrafico = 1
          grplot(nGrafico)%npoints = 0
      elseif (iAction == 2) then
          if (ifVLD == 0) then
              nGrafico = numbrun
          else
              nGrafico = 1
          endif
          rFac = erre * 100.0
          if (nint(rFac) > 0) then
              call gr_add_point_plot(grplot(nGrafico),
     *                               real(nCycleVLD),rFac)
              if (viewerOpened == 1) then
                  call gr_select_viewer(1)
                  call gr_clear_area(0.0,1.0,0.0,1.0)
                  call gr_area(0.08, 0.99, 0.15, 0.99)
                  call gr_set_graph(grgraph,
     *                              color=grplot(nGrafico)%colorline,
     *                              spacex=0.05)
                  call gr_draw_graph(grgraph,grplot)
                  call zflush()
                  call gr_select_viewer(0)
               endif
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RWindMainWindow(iAction)
      USE General, only : knw
      USE Molcom
      Use PhaseModule, only: erre,nTotBlocksPh,numbrun,FinalFom
      USE grexpomod
      USE Grafici
      USE VLDmod_3
      USE VLDmod
!
!--  Action = 0 allocate
!--         = 1 clear plot
!--         = 2 add value to plot
!--         = 3 update plotted value
!--         = 4 plot only
!
      implicit none
      integer, dimension(0:6) :: vcolor
      integer                 :: i, iAction, nGr, MaxTrials, pcol, ncyc
      real                    :: rFac, FomFinale
      type(graph_type),save   :: grgraph1, grgraph2
      type(plot_type), save,dimension(:), allocatable ::grplot1, grplot2
!
      if (jscreen == 0) return
!
      FomFinale = FinalFom
      FomFinale = FinalFom2
      MaxTrials = 1
!
      if (iAction == 0 .and. firstTime == 1) then    ! allocate
!
         firstTime = 0
         call gr_setbackground(color_BRIGHTWHITE)
         vcolor = (/color_BROWN,color_LIGHTBLUE,color_LIGHTRED,
     *             color_LIGHTGREEN, color_LIGHTCYAN,
     *             color_LIGHTMAGENTA, color_YELLOW/)
        call gr_create_graph(grgraph1)
        call gr_set_graph(grgraph1,stringx='EDM Cycles',stringy='SaFOM',
     *                    spacex=0.05)
        call gr_create_graph(grgraph2)
        call gr_set_graph(grgraph2,stringx='EDM Cycles',stringy='fFOM',
     *                    spacex=0.05)
         if (allocated(grplot1)) then
             if (size(grplot1) /= MaxTrials) then
                 deallocate(grplot1)
                 allocate(grplot1(MaxTrials))
             endif
         else
             allocate(grplot1(MaxTrials))
         endif
         if (allocated(grplot2)) then
             if (size(grplot2) /= MaxTrials) then
                 deallocate(grplot2)
                 allocate(grplot2(MaxTrials))
             endif
         else
             allocate(grplot2(MaxTrials))
         endif
         do i=1,MaxTrials
            call gr_new_plot(grplot1(i),100)
            call gr_new_plot(grplot2(i),100)
            pcol = mod(i,size(vcolor))
            call gr_set_plot(grplot1(i),colorline=vcolor(1))
            call gr_set_plot(grplot2(i),colorline=vcolor(2))
         enddo
!
      elseif (iAction == 1) then    ! clear plot
!
          grplot1%npoints = 0
          grplot2%npoints = 0
!
      elseif (iAction == 2) then    ! add value to plot
!
          nGr = numbrun
          nGr = WhichVldPlot
          if (WhichVldPlot == 1) then
*             rFac = Rat_VLD
              rFac = sigmaA_1              ! 18/05/2011
              if (rFac > Rat_VLD) then
                  rFac = Rat_VLD
              end if
              ncyc = numero_cicli
          else
              rFac = FomFinale
              ncyc = numero_cicli
          endif
          if (abs(rFac) > 0.0) then
              call gr_clear_area(xHistF(1,nGr), xHistF(2,nGr),
     *                           yHistF(1,nGr), yHistF(2,nGr))
              call gr_area(xHisto(1,nGr), xHisto(2,nGr),
     *                     yHisto(1,nGr), yHisto(2,nGr))
              if (nGr == 1) then
                  call gr_add_point_plot(grplot1(1),
     *                               real(ncyc),rFac)
                  call gr_set_graph(grgraph1,
     *                              color=grplot1(1)%colorline,
     *                              spacex=0.05)
                  call gr_draw_graph(grgraph1,grplot1)
              else
                  call gr_add_point_plot(grplot2(1),
     *                               real(ncyc),rFac)
                  call gr_set_graph(grgraph2,
     *                              color=grplot2(1)%colorline,
     *                              spacex=0.05)
                  call gr_draw_graph(grgraph2,grplot2)
              endif
              call zflush()
          endif
!
      elseif (iAction == 3) then     ! update
!
          rFac = FomFinale
          ncyc = numero_cicli
          grplot2(1)%point(grplot2%npoints)%x = ncyc
          grplot2(1)%point(grplot2%npoints)%y = rFac
!
      elseif (iAction == 4) then     ! plot only
!
          nGr = 1
          call gr_clear_area(xHistF(1,nGr), xHistF(2,nGr),
     *                       yHistF(1,nGr), yHistF(2,nGr))
          call gr_area(xHisto(1,nGr), xHisto(2,nGr),
     *                 yHisto(1,nGr), yHisto(2,nGr))
          call gr_set_graph(grgraph1, color=grplot1(1)%colorline,
     *                      spacex=0.05)
          call gr_draw_graph(grgraph1,grplot1)

          nGr = 2
          call gr_clear_area(xHistF(1,nGr), xHistF(2,nGr),
     *                       yHistF(1,nGr), yHistF(2,nGr))
          call gr_area(xHisto(1,nGr), xHisto(2,nGr),
     *                 yHisto(1,nGr), yHisto(2,nGr))
          call gr_set_graph(grgraph2, color=grplot2(1)%colorline,
     *                      spacex=0.05)
          call gr_draw_graph(grgraph2,grplot2)

          call zflush()

      endif
!
      return
      end
